# Ngx Academia Uniandes Library

This library is used for Academia-Uniandes system. 

## Install

Use [npm](https://www.npmjs.com) package manager and execute following command:

  `npm i ngx-academia-uniandes-library --save`

Then import any avaliable *ngx-academia-uniandes* module in your main module. The following example imports *SearchComboBoxModule* module.

```typescript
    import { AppComponent } from './app.component';
    import { SearchComboBoxModule } from 'ngx-academia-uniandes';



    @NgModule({
    declarations: [
        AppComponent
    ],
    imports: [
        BrowserModule,
        SearchComboBoxModule
    ],
    providers: [],
    bootstrap: [AppComponent]
    })
    export class AppModule { }
```


## List of available components in **ngx-academia-uniandes**

* [Search Box Combo Box Components](./doc/SEARCHBOX.md)
* [Academia Widgets](./doc/ACADEMYWIDGETS.md)
* [Crud Compact](./doc/CRUDCOMPACT.md)
* [Academy Paginator](./doc/PAGINATOR.md)
* [Check Bar State](./doc/CHECKBARSTATE.md)
* [File Upload](./doc/FILEUPLOAD.md)




© 2019


       _____                     .___             .__        
      /  _  \   ____ _____     __| _/____   _____ |__|____   
     /  /_\  \_/ ___\\__  \   / __ |/ __ \ /     \|  \__  \  
    /    |    \  \___ / __ \_/ /_/ \  ___/|  Y Y  \  |/ __ \_
    \____|__  /\___  >____  /\____ |\___  >__|_|  /__(____  /
            \/     \/     \/      \/    \/      \/        \/ 
    
    ____ ___      .__                   .___             
    |    |   \____ |__|____    ____    __| _/____   ______
    |    |   /    \|  \__  \  /    \  / __ |/ __ \ /  ___/
    |    |  /   |  \  |/ __ \|   |  \/ /_/ \  ___/ \___ \ 
    |______/|___|  /__(____  /___|  /\____ |\___  >____  >
                    \/        \/     \/      \/    \/     \/ 


