"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var modal_1 = require("ngx-bootstrap/modal");
var core_2 = require("@ngx-translate/core");
var research_group_lines_list_service_1 = require("./research.group.lines.list.service");
var research_group_lines_list_servicemodel_1 = require("./research.group.lines.list.servicemodel");
var research_group_lines_list_model_1 = require("./research.group.lines.list.model");
var service_locator_1 = require("../../../../service-locator");
var utils_1 = require("../../../../utils/utils");
var forms_1 = require("@angular/forms");
var Subscription_1 = require("rxjs/Subscription");
var ResearchGroupLinesListComponent = /** @class */ (function () {
    function ResearchGroupLinesListComponent(_formBuilder, cd, urlService, service, transService, titlecasePipe) {
        this._formBuilder = _formBuilder;
        this.cd = cd;
        this.urlService = urlService;
        this.service = service;
        this.transService = transService;
        this.titlecasePipe = titlecasePipe;
        this.onMultiSelection = new core_1.EventEmitter();
        this.selectedElements = [];
        this.data = [];
        this.currentIndex = -1;
        this.currentIndex1 = -1;
        this.isFetchFinish = false;
        this.eventListenerRG = new Subscription_1.Subscription();
        this.eventListenerRL = new Subscription_1.Subscription();
        this.totalRecords = 0;
        this.start = 0;
        this.page = 1;
        this.pageSize = 10;
        this.totalRe = 10;
        this.formGroup = this._formBuilder.group({
            researchGroupCtrl: ['', forms_1.Validators.compose([forms_1.Validators.required])],
        });
        this.modelServiceRG = new research_group_lines_list_servicemodel_1.ResearchGroupLinesListServiceModel(urlService.getResearchGroupsUrl(), [{ "name": "limit", "value": this.pageSize }, { "name": "offset", "value": this.start }], "", "name"); //researchGroups
        this.modelServiceRL = new research_group_lines_list_servicemodel_1.ResearchGroupLinesListServiceModel(urlService.getResearchLinesUrl(), [], "invLines", "name");
    }
    Object.defineProperty(ResearchGroupLinesListComponent.prototype, "preSelect", {
        set: function (elements) {
            this.preSelectedElements = elements;
            this.preSelectAction();
        },
        enumerable: true,
        configurable: true
    });
    ResearchGroupLinesListComponent.prototype.ngOnInit = function () {
        this.setUrlServiceHost();
        this.setData();
    };
    ResearchGroupLinesListComponent.prototype.ngOnDestroy = function () {
        this.eventListenerRG.unsubscribe();
        this.eventListenerRL.unsubscribe();
    };
    ResearchGroupLinesListComponent.prototype.setUrlServiceHost = function () {
        if (this.debugFlag) {
            this.modelServiceRG.urlService = this.urlService.getResearchGroupsUrl(this.debugFlag);
            this.modelServiceRL.urlService = this.urlService.getResearchLinesUrl(this.debugFlag);
        }
    };
    ResearchGroupLinesListComponent.prototype.reset = function () {
        this.data.forEach(function (elementRG) {
            elementRG.selected = false;
            elementRG.lines.forEach(function (elementRL) {
                elementRL.selected = false;
            });
        });
        this.selectedElements = [];
        this.selectFirstDefault();
        this.fireSelectEvents();
    };
    ResearchGroupLinesListComponent.prototype.select = function () {
        this.preSelectAction();
    };
    ResearchGroupLinesListComponent.prototype.openDialogMulti = function () {
        this.modalDirectiveMulti.show();
    };
    ResearchGroupLinesListComponent.prototype.closeDialogMulti = function () {
        this.modalDirectiveMulti.hide();
    };
    ResearchGroupLinesListComponent.prototype.setData = function () {
        var _this = this;
        this.isFetchFinish = false;
        this.eventListenerRG = this.searchData(this.modelServiceRG).subscribe(function (valuesRG) {
            var totalRG = valuesRG.researchGroups.length;
            var currentRG = 0;
            _this.data = [];
            _this.totalRecords = valuesRG.totalRGroups;
            valuesRG.researchGroups.map(function (element) {
                _this.eventListenerRL = _this.searchData(_this.modelServiceRL, element).subscribe(function (valuesRL) {
                    var dataRL = [];
                    currentRG++;
                    valuesRL.lines.map(function (element2) {
                        dataRL.push(new research_group_lines_list_model_1.ResearchGroupLinesListModel(element2.external_id, false, element2, undefined));
                    });
                    var modelData = new research_group_lines_list_model_1.ResearchGroupLinesListModel(valuesRL.externalId, false, valuesRL, dataRL);
                    _this.data.push(modelData);
                    if (totalRG == currentRG) {
                        _this.isFetchFinish = true;
                        _this.selectionParamsAfterReset();
                        _this.cd.detectChanges();
                    }
                }, function (error) {
                    console.error(error);
                    _this.isFetchFinish = true;
                    _this.cd.detectChanges();
                });
            });
        }, function (error) {
            console.error(error);
            _this.isFetchFinish = true;
        });
    };
    ResearchGroupLinesListComponent.prototype.searchData = function (componentModel, parent) {
        return this.service.getItems(componentModel, parent && parent.externalId ? parent.externalId : undefined).map(function (values) {
            if (parent && parent.externalId) {
                parent.lines = values[componentModel.collectionName] ? values[componentModel.collectionName] : values;
                return parent;
            }
            else
                return values[componentModel.collectionName] ? values[componentModel.collectionName] : values;
        });
    };
    //Fires after data population on child
    //Fires after data population on child
    ResearchGroupLinesListComponent.prototype.selectionParamsAfterReset = 
    //Fires after data population on child
    function () {
        this.selectFirstDefault();
        this.preSelectAction();
        this.fireSelectEvents();
    };
    ResearchGroupLinesListComponent.prototype.preSelectAction = function () {
        var _this = this;
        if (this.preSelectedElements != null && this.data != null) {
            if (this.preSelectedElements.length > 0) {
                this.data.map(function (element) {
                    element.selected = false;
                });
                // adds the items entered in the selected array
                this.preSelectedElements.forEach(function (RGSelectVal) {
                    var exist = true;
                    _this.selectedElements.forEach(function (RG) {
                        if (RGSelectVal.externalId == RG.externalId) {
                            exist = false;
                            return;
                        }
                    });
                    if (exist) {
                        _this.selectedElements.push(RGSelectVal);
                    }
                });
                // search for the selected items in the data model that is drawn in the graphical interface
                this.data.map(function (RG) {
                    _this.preSelectedElements.forEach(function (RGSelectVal) {
                        if (RG.object && RGSelectVal.externalId && RG.nameid == RGSelectVal.externalId) {
                            RG.selected = true;
                            if (RG.lines && RGSelectVal.lines) {
                                RG.lines.map(function (RL) {
                                    RGSelectVal.lines.map(function (RLSelectVal) {
                                        if (RLSelectVal.externalId && RL.nameid == RLSelectVal.externalId) {
                                            RL.selected = true;
                                            return;
                                        }
                                    });
                                });
                            }
                        }
                    });
                });
            }
        }
    };
    ResearchGroupLinesListComponent.prototype.fireSelectEvents = function () {
        this.onMultiSelectionChange();
    };
    ResearchGroupLinesListComponent.prototype.onMultiSelectionChange = function () {
        this.onMultiSelection.emit(this.selectedElements);
    };
    // Click event on multi select mode
    // Click event on multi select mode
    ResearchGroupLinesListComponent.prototype.onMultipleListElementClicked = 
    // Click event on multi select mode
    function (element, type) {
        if (element.selected) {
            this.getSelectedElements(element, type);
        }
        else {
            this.getUnselectedElements(element, type);
        }
        this.onMultiSelectionChange();
    };
    ResearchGroupLinesListComponent.prototype.getSelectedElements = function (element, type) {
        var _this = this;
        var elementSelect = null;
        if (type == "RG") {
            if (!this.getSearchRgSelected(type, element)) {
                elementSelect = element.object;
                elementSelect.lines = [];
                if (element.lines && element.lines.length > 0) {
                    element.lines.map(function (RL) {
                        RL.selected = element.selected;
                        elementSelect.lines.push(RL.object);
                    });
                }
            }
        }
        else if (type == "RL") {
            var seleccion_1 = false;
            this.data.map(function (RG) {
                if (RG.lines && RG.lines.length > 0) {
                    RG.lines.map(function (RL) {
                        if (RL.nameid === element.nameid) {
                            if (!_this.getSearchRgSelected(type, RG, element)) {
                                elementSelect = RG.object;
                                elementSelect.lines = [];
                                elementSelect.lines.push(RL.object);
                                RG.selected = true;
                            }
                            seleccion_1 = true;
                            return;
                        }
                    });
                    if (seleccion_1) {
                        return;
                    }
                }
            });
        }
        if (elementSelect)
            this.selectedElements.push(elementSelect);
    };
    ResearchGroupLinesListComponent.prototype.getUnselectedElements = function (element, type) {
        var _this = this;
        if (type == "RG" && this.selectedElements.length > 0) {
            if (element.lines) {
                element.lines.map(function (RL) {
                    RL.selected = element.selected;
                });
            }
            this.selectedElements.map(function (RG, index) {
                if (RG.externalId && RG.externalId == element.nameid) {
                    _this.selectedElements.splice(index, 1);
                    return;
                }
            });
        }
        else if (type == "RL" && this.selectedElements.length > 0) {
            this.selectedElements.map(function (RG) {
                if (RG.lines) {
                    RG.lines.map(function (RL, index) {
                        if (RL.external_id && RL.external_id == element.nameid) {
                            RG.lines.splice(index, 1);
                            return;
                        }
                    });
                }
            });
        }
    };
    ResearchGroupLinesListComponent.prototype.getSearchRgSelected = function (type, element, element2) {
        var seleccion = false;
        if (type == "RG" && this.selectedElements.length > 0) {
            this.selectedElements.map(function (RG) {
                if (RG.externalId && RG.externalId == element.nameid) {
                    seleccion = true;
                    return;
                }
            });
        }
        else if (type == "RL" && this.selectedElements.length > 0) {
            this.selectedElements.map(function (RG) {
                if (RG.externalId && RG.externalId == element.nameid) {
                    if (RG.lines) {
                        RG.lines.push(element2.object);
                        seleccion = true;
                        return;
                    }
                }
            });
        }
        return seleccion;
    };
    ResearchGroupLinesListComponent.prototype.selectFirstDefault = function () {
        if (this.selectFirst) {
            if (this.data.length > 0) {
                var fnd_1 = false;
                this.data.forEach(function (element) {
                    if (!fnd_1) {
                        element.selected = true;
                        fnd_1 = true;
                    }
                });
            }
        }
    };
    ResearchGroupLinesListComponent.prototype.deleteItem = function (element, type) {
        var _this = this;
        var select_from = element.externalId ? element.externalId : element.external_id;
        if (type == "RG" && this.selectedElements.length > 0) {
            this.selectedElements.map(function (RG, index) {
                var select_to = RG.externalId ? RG.externalId : RG.external_id;
                if (select_from && select_to && select_from == select_to) {
                    _this.selectedElements.splice(index, 1);
                    _this.onMultiSelectionChange();
                    return;
                }
            });
        }
        else if (type == "RL" && this.selectedElements.length > 0) {
            this.selectedElements.map(function (RG) {
                if (RG.lines) {
                    RG.lines.map(function (RL, index) {
                        var select_to = RL.externalId ? RL.externalId : RL.external_id;
                        if (select_from && select_to && select_from == select_to) {
                            RG.lines.splice(index, 1);
                            _this.onMultiSelectionChange();
                            return;
                        }
                    });
                }
            });
        }
    };
    ResearchGroupLinesListComponent.prototype.getPageResearchGroup = function () {
        var initPage = 10 * (this.page - 1);
        var endPage = (10 * this.page) + 10;
        endPage < this.data.length ? endPage : endPage = this.data.length;
        return this.data.slice(initPage, endPage);
    };
    ResearchGroupLinesListComponent.prototype.pageChanged = function (obj) {
        this.start = obj.page * obj.pageSize - obj.pageSize;
        this.page = obj.page;
        this.pageSize = obj.pageSize;
        this.modelServiceRG.queryParams = [{ "name": "limit", "value": this.pageSize }, { "name": "offset", "value": this.start }];
        this.setUrlServiceHost();
        this.setData();
    };
    ResearchGroupLinesListComponent.prototype.setResearchGroup = function (event) {
        this.modelServiceRG.queryParams = event ? [{ "name": "query", "value": event.value }, { "name": "offset", "value": this.start }, { "name": "limit", "value": this.pageSize }]
            : [{ "name": "limit", "value": this.pageSize }, { "name": "offset", "value": this.start }];
        this.setUrlServiceHost();
        this.setData();
    };
    ResearchGroupLinesListComponent.prototype.openResearchLine = function (index) {
        if (this.currentIndex === -1 || this.currentIndex !== index) {
            this.currentIndex = index;
        }
        else if (this.currentIndex === index) {
            this.currentIndex = -1;
        }
    };
    ResearchGroupLinesListComponent.prototype.openResearchLine1 = function (index) {
        if (this.currentIndex1 === -1 || this.currentIndex1 !== index) {
            this.currentIndex1 = index;
        }
        else if (this.currentIndex1 === index) {
            this.currentIndex1 = -1;
        }
    };
    ResearchGroupLinesListComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-research-group-lines-list',
                    template: "\n    <ng-template #checkresearchgroupcategorycpt [ngIf]=\"true\">\n\n      <div class=\"content-select\">\n        <div  *ngIf=\"!readonly\" class=\"content-select-txt\">\n          <p class=\"txt-select-rg\">{{'selectResearchGroupCategory' | translate}}: </p>\n        </div>\n        <div  *ngIf=\"!readonly\" class=\"content-select-btn\">\n          <button [disabled]=\"disabled\" class=\"btn btn-default btn-select-rg\"\n            (click)=\"openDialogMulti()\">{{'select'| translate}}</button>\n        </div>\n        <div class=\"content-select-result\">\n          <ul class=\"list-group\" *ngIf=\"selectedElements.length > 0\">\n            <ng-container *ngFor=\"let researchGroup of selectedElements; index as j\">\n              <li class=\"list-group-item item-course\">\n                <div class=\"content-rg\">\n                  <div class=\"btn-nodes\">\n                    <i *ngIf=\"researchGroup.lines.length > 0\" (click)=\"openResearchLine1(j)\"\n                      class=\"material-icons icon-arrow\">{{(currentIndex1 === j ? \"expand_more\" : \"chevron_right\")}}</i>\n                  </div>\n                  <div class=\"description-rg\">\n                    {{researchGroup.name | translate}}\n                  </div>\n                  <div *ngIf=\"!readonly\" class=\"btn-close\">\n                    <i (click)=\"deleteItem(researchGroup, 'RG')\" class=\"material-icons icon-arrow\">cancel</i>\n                  </div>\n                </div>\n              </li>\n              <div class=\"content-child-session\" *ngIf=\"currentIndex1 === j\" [@enterAnimation]>\n                <ul class=\"list-group\">\n                  <ng-container *ngFor=\"let researchLine of researchGroup.lines\">\n                    <li class=\"list-group-item item-course\">\n                      <div class=\"content-rg\">\n                        <div class=\"btn-nodes\">\n                          <i class=\"material-icons icon-check\">check_box</i>\n                        </div>\n                        <div class=\"description-rl\">\n                          {{researchLine.name}}\n                        </div>\n                        <div *ngIf=\"!readonly\" class=\"btn-close\">\n                            <i (click)=\"deleteItem(researchLine, 'RL')\" class=\"material-icons icon-arrow\">cancel</i>\n                          </div>\n                      </div>\n                    </li>\n                  </ng-container>\n                </ul>\n              </div>\n            </ng-container>\n          </ul>\n        </div>\n      </div>\n\n      <div class=\"modal fade research-group-lines-list\" [config]=\"{backdrop: 'static'}\" bsModal\n        #researchgrouplinesdialogmulti=\"bs-modal\" tabindex=\"-1\" role=\"dialog\">\n        <div class=\"modal-dialog\" role=\"document\">\n          <div class=\"modal-content\">\n            <div class=\"modal-header\">\n              <table class=\"table-list\">\n                <tr>\n                  <td>\n                    <b>{{'groupsAndInvestigationLinesTitle' | translate}}</b>\n                  </td>\n                  <td>\n                    <button (click)=\"closeDialogMulti()\" type=\"button\" class=\"close\" data-dismiss=\"modal\"\n                      aria-label=\"Close\">\n                      <span aria-hidden=\"true\">&times;</span>\n                    </button>\n                  </td>\n\n                </tr>\n              </table>\n            </div>\n            <div align=\"center\" class=\"modal-body\">\n              <div class=\"txt-info\">\n                <p>{{'groupsAndInvestigationLinesSelecterMessage' | translate}}</p>\n              </div>\n\n              <div class=\"txt-search\">\n                <search-research-group-combo-box [debugFlag]=debugFlag [isScrollable]=false\n                  [itemControl]=\"formGroup.controls.researchGroupCtrl\" [placeHolder]=\"'selectResearchGroup'\"\n                  [queryParams]=\"[{'name':'limit','value': 5}]\" (itemSelected)=\"setResearchGroup($event)\">\n                </search-research-group-combo-box>\n              </div>\n\n              <div class=\"List\">\n                <ul class=\"list-group\">\n                  <ng-container *ngFor=\"let researchGroup of data; index as i\">\n                    <li class=\"list-group-item item-course\">\n                      <div class=\"content-rg\">\n                        <div class=\"btn-nodes\">\n                          <i *ngIf=\"researchGroup.lines.length > 0\" (click)=\"openResearchLine(i)\"\n                            class=\"material-icons icon-arrow\">{{(currentIndex === i ? \"expand_more\" : \"chevron_right\")}}</i>\n                        </div>\n                        <div class=\"chk-rg\">\n                          <input class=\"check-function\" (change)=\"onMultipleListElementClicked(researchGroup, 'RG')\"\n                            type=\"checkbox\" [(ngModel)]=\"researchGroup.selected\">\n                        </div>\n                        <div class=\"description-rg\">\n                          {{researchGroup.object.name}}\n                        </div>\n                      </div>\n                    </li>\n                    <div class=\"content-child-session\" *ngIf=\"currentIndex === i\" [@enterAnimation]>\n                      <ul class=\"list-group\">\n                        <ng-container *ngFor=\"let researchLine of researchGroup.lines\">\n                          <li class=\"list-group-item item-course\">\n                            <div class=\"content-rg\">\n                              <div class=\"chk-rl\">\n                                <input class=\"check-function\" (change)=\"onMultipleListElementClicked(researchLine, 'RL')\"\n                                  type=\"checkbox\" [(ngModel)]=\"researchLine.selected\">\n                              </div>\n                              <div class=\"description-rl\">\n                                {{researchLine.object.name}}\n                              </div>\n                            </div>\n                          </li>\n                        </ng-container>\n                      </ul>\n                    </div>\n                  </ng-container>\n                </ul>\n\n                <div class=\"no-items\" *ngIf=\"!data || data.length == 0 \">\n                  <div class=\"center-img-text\" *ngIf=\"!isFetchFinish\">\n\n                    <div class=\"lds-spin\" style=\"width:100%;height:100%\">\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                      <div>\n                        <div></div>\n                      </div>\n                    </div>\n\n                  </div>\n                  <div class=\"center-img-text\" *ngIf=\"isFetchFinish\">\n                    <h2><span class=\"oi oi-magnifying-glass\"></span> {{ 'noResults' | translate}}</h2>\n                  </div>\n                </div>\n\n                <div class=\"row cont-paginador\">\n                  <div class=\"offset-lg-1 col-lg-8\">\n                    <academia-pagination [collectionSize]=\"totalRecords\" [fullPaginator]=false [pageSize]=\"pageSize\"\n                      [page]=\"page\" (pageChanged)=\"pageChanged($event)\"></academia-pagination>\n                  </div>\n                </div>\n\n              </div>\n\n            </div>\n            <div align=\"center\" class=\"modal-footer\">\n              <button type=\"button\" class=\"btn btn-lg btn-uniandes-main\"\n                (click)=\"closeDialogMulti()\">{{'close' | translate}}</button>\n            </div>\n          </div>\n\n        </div>\n      </div>\n\n      <!-- protected region developer's' code on begin -->\n      <!-- protected region developer's' code end -->\n\n    </ng-template>\n  ",
                    styles: ["\n    .research-group-lines-list .item-course {\n      padding: 0.4rem 0.5rem;\n    }\n\n    .research-group-lines-list .content-rg, .content-select-result .content-rg {\n      display: flex;\n      align-content: center;\n    }\n\n    .research-group-lines-list .chk-rg {\n      flex: 0 0 5%;\n      order: 2;\n    }\n\n    .research-group-lines-list .chk-rl {\n      flex: 0 0 5%;\n      order: 2;\n      padding-left: 2rem;\n    }\n\n    .research-group-lines-list .btn-nodes, .content-select-result .btn-nodes {\n      flex: 0 0 5%;\n      order: 1;\n    }\n\n    .content-select-result .btn-close {\n      flex: 0 0 5%;\n      order: 4;\n    }\n\n    .research-group-lines-list .description-rg, .content-select-result .description-rg {\n      flex: 0 0 90%;\n      order: 3;\n      margin-top: 0.3rem;\n      text-align: left;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      padding-right: 0.4rem;\n      padding-left: 0.4rem;\n    }\n\n    .research-group-lines-list .description-rl, .content-select-result .description-rl {\n      flex: 0 0 90%;\n      order: 3;\n      margin-top: 0.2rem;\n      text-align: left;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      padding-right: 0.4rem;\n      padding-left: 0.4rem;\n    }\n\n    .research-group-lines-list .check-function{\n      float: left;\n      position: relative;\n      margin-top: 5px;\n    }\n\n    .research-group-lines-list .icon-arrow{\n      font-size: 1.4rem;\n      float: left;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .content-select-result .icon-arrow {\n      font-size: 1.4rem;\n      float: right;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .content-select-result .icon-check {\n      font-size: 1.1rem;\n      float: right;\n      position: relative;\n    }\n\n    .research-group-lines-list .cont-paginador {\n      margin-top: 1rem;\n    }\n\n    .research-group-lines-list .txt-info {\n      text-align: left;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n    }\n\n    .research-group-lines-list .txt-search {\n      margin: 1rem 0rem;\n    }\n\n    .no-items {\n      display: grid;\n      grid-template-columns: 1fr;\n      grid-template-rows: 1fr;\n    }\n\n    .center-img-text {\n      display: flex;\n      align-items: center;\n      justify-content: center;\n      height: 500px;\n    }\n\n    .content-select {\n      display: flex;\n      align-content: center;\n      flex-wrap: wrap;\n      align-items: center;\n      justify-content: center;\n    }\n\n    .content-select .content-select-txt {\n      flex: 0 0 50%;\n      order: 1;\n      padding: 0.5rem 1rem;\n    }\n\n    .content-select .content-select-btn {\n      flex: 0 0 50%;\n      order: 2;\n      padding: 0.5rem 1rem;\n    }\n\n    .content-select .content-select-result {\n      flex: 0 0 100%;\n      order: 3;\n      padding: 0.5rem 1rem;\n    }\n\n    .content-select .content-select-txt .txt-select-rg{\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      float: right;\n      margin: 0.5rem 0.2rem\n    }\n    .content-select .content-select-btn .btn-select-rg{\n      float: left;\n    }\n\n    /************** Spinner (Cargando) ***************/\n\n    @keyframes lds-spin {\n      0% {\n        opacity: 1;\n        -webkit-transform: scale(1.1, 1.1);\n        transform: scale(1.1, 1.1);\n      }\n      100% {\n        opacity: 0;\n        -webkit-transform: scale(1, 1);\n        transform: scale(1, 1);\n      }\n    }\n    @-webkit-keyframes lds-spin {\n      0% {\n        opacity: 1;\n        -webkit-transform: scale(1.1, 1.1);\n        transform: scale(1.1, 1.1);\n      }\n      100% {\n        opacity: 0;\n        -webkit-transform: scale(1, 1);\n        transform: scale(1, 1);\n      }\n    }\n    .lds-spin {\n      position: relative;\n    }\n    .lds-spin div > div {\n      position: absolute;\n      width: 40px;\n      height: 40px;\n      border-radius: 50%;\n      background: #28292f;\n      -webkit-animation: lds-spin 1s linear infinite;\n      animation: lds-spin 1s linear infinite;\n    }\n    .lds-spin div:nth-child(1) > div {\n      left: 140px;\n      top: 80px;\n      -webkit-animation-delay: -0.875s;\n      animation-delay: -0.875s;\n    }\n    .lds-spin > div:nth-child(1) {\n      -webkit-transform: rotate(0deg);\n      transform: rotate(0deg);\n      -webkit-transform-origin: 160px 100px;\n      transform-origin: 160px 100px;\n    }\n    .lds-spin div:nth-child(2) > div {\n      left: 122.42640685999999px;\n      top: 122.42640685999999px;\n      -webkit-animation-delay: -0.75s;\n      animation-delay: -0.75s;\n    }\n    .lds-spin > div:nth-child(2) {\n      -webkit-transform: rotate(45deg);\n      transform: rotate(45deg);\n      -webkit-transform-origin: 142.42640686px 142.42640686px;\n      transform-origin: 142.42640686px 142.42640686px;\n    }\n    .lds-spin div:nth-child(3) > div {\n      left: 80px;\n      top: 140px;\n      -webkit-animation-delay: -0.625s;\n      animation-delay: -0.625s;\n    }\n    .lds-spin > div:nth-child(3) {\n      -webkit-transform: rotate(90deg);\n      transform: rotate(90deg);\n      -webkit-transform-origin: 100px 160px;\n      transform-origin: 100px 160px;\n    }\n    .lds-spin div:nth-child(4) > div {\n      left: 37.57359314px;\n      top: 122.42640685999999px;\n      -webkit-animation-delay: -0.5s;\n      animation-delay: -0.5s;\n    }\n    .lds-spin > div:nth-child(4) {\n      -webkit-transform: rotate(135deg);\n      transform: rotate(135deg);\n      -webkit-transform-origin: 57.57359314px 142.42640686px;\n      transform-origin: 57.57359314px 142.42640686px;\n    }\n    .lds-spin div:nth-child(5) > div {\n      left: 20px;\n      top: 80px;\n      -webkit-animation-delay: -0.375s;\n      animation-delay: -0.375s;\n    }\n    .lds-spin > div:nth-child(5) {\n      -webkit-transform: rotate(180deg);\n      transform: rotate(180deg);\n      -webkit-transform-origin: 40px 100px;\n      transform-origin: 40px 100px;\n    }\n    .lds-spin div:nth-child(6) > div {\n      left: 37.57359314px;\n      top: 37.57359314px;\n      -webkit-animation-delay: -0.25s;\n      animation-delay: -0.25s;\n    }\n    .lds-spin > div:nth-child(6) {\n      -webkit-transform: rotate(225deg);\n      transform: rotate(225deg);\n      -webkit-transform-origin: 57.57359314px 57.57359314px;\n      transform-origin: 57.57359314px 57.57359314px;\n    }\n    .lds-spin div:nth-child(7) > div {\n      left: 80px;\n      top: 20px;\n      -webkit-animation-delay: -0.125s;\n      animation-delay: -0.125s;\n    }\n    .lds-spin > div:nth-child(7) {\n      -webkit-transform: rotate(270deg);\n      transform: rotate(270deg);\n      -webkit-transform-origin: 100px 40px;\n      transform-origin: 100px 40px;\n    }\n    .lds-spin div:nth-child(8) > div {\n      left: 122.42640685999999px;\n      top: 37.57359314px;\n      -webkit-animation-delay: 0s;\n      animation-delay: 0s;\n    }\n    .lds-spin > div:nth-child(8) {\n      -webkit-transform: rotate(315deg);\n      transform: rotate(315deg);\n      -webkit-transform-origin: 142.42640686px 57.57359314px;\n      transform-origin: 142.42640686px 57.57359314px;\n    }\n    .lds-spin div:nth-child(9) > div {\n      left: 140px;\n      top: 80px;\n      -webkit-animation-delay: 0.125s;\n      animation-delay: 0.125s;\n    }\n    .lds-spin > div:nth-child(9) {\n      -webkit-transform: rotate(360deg);\n      transform: rotate(360deg);\n      -webkit-transform-origin: 160px 100px;\n      transform-origin: 160px 100px;\n    }\n    .lds-spin {\n      width: 200px !important;\n      height: 200px !important;\n      -webkit-transform: translate(-100px, -100px) scale(1) translate(100px, 100px);\n      transform: translate(-100px, -100px) scale(1) translate(100px, 100px);\n    }\n    /*Common Styles*/\n    /*Buttons*/\n\n    .btn-uniandes-main { \n        color: #000000; \n        background-color: #FFFF00; \n        border-color: none; \n      } \n   \n      .btn-uniandes-main:hover, \n      .btn-uniandes-main:focus, \n      .btn-uniandes-main:active, \n      .btn-uniandes-main.active, \n      .open .dropdown-toggle.btn-uniandes-main { \n        color: #000000; \n        background-color: #DBD000; \n        border-color: none ; \n      } \n   \n      .btn-uniandes-main:active, \n      .btn-uniandes-main.active, \n      .open .dropdown-toggle.btn-uniandes-main { \n        background-image: none; \n      } \n   \n      .btn-uniandes-main.disabled, \n      .btn-uniandes-main[disabled], \n      fieldset[disabled] .btn-uniandes-main, \n      .btn-uniandes-main.disabled:hover, \n      .btn-uniandes-main[disabled]:hover, \n      fieldset[disabled] .btn-uniandes-main:hover, \n      .btn-uniandes-main.disabled:focus, \n      .btn-uniandes-main[disabled]:focus, \n      fieldset[disabled] .btn-uniandes-main:focus, \n      .btn-uniandes-main.disabled:active, \n      .btn-uniandes-main[disabled]:active, \n      fieldset[disabled] .btn-uniandes-main:active, \n      .btn-uniandes-main.disabled.active, \n      .btn-uniandes-main[disabled].active, \n      fieldset[disabled] .btn-uniandes-main.active { \n        background-color: #FFFF00; \n        border-color: none; \n      } \n   \n      .btn-uniandes-main .badge { \n        color: #FFFF00; \n        background-color: #000000; \n      }\n\n\n      .btn-uniandes-secondary { \n        color: #ffffff; \n        background-color: #000000; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary:hover, \n      .btn-uniandes-secondary:focus, \n      .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.active, \n      .open .dropdown-toggle.btn-uniandes-secondary { \n        color: #ffffff; \n        background-color: #707070; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.active, \n      .open .dropdown-toggle.btn-uniandes-secondary { \n        background-image: none; \n      } \n   \n      .btn-uniandes-secondary.disabled, \n      .btn-uniandes-secondary[disabled], \n      fieldset[disabled] .btn-uniandes-secondary, \n      .btn-uniandes-secondary.disabled:hover, \n      .btn-uniandes-secondary[disabled]:hover, \n      fieldset[disabled] .btn-uniandes-secondary:hover, \n      .btn-uniandes-secondary.disabled:focus, \n      .btn-uniandes-secondary[disabled]:focus, \n      fieldset[disabled] .btn-uniandes-secondary:focus, \n      .btn-uniandes-secondary.disabled:active, \n      .btn-uniandes-secondary[disabled]:active, \n      fieldset[disabled] .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.disabled.active, \n      .btn-uniandes-secondary[disabled].active, \n      fieldset[disabled] .btn-uniandes-secondary.active { \n        background-color: #000000; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary .badge { \n        color: #000000; \n        background-color: #ffffff; \n      }\n\n    /*Dialogs*/\n    .modal-header{\n        padding: 0px;\n        border: 0px;\n        background-color: #FFFF00;\n    }\n\n    .modal-header table{\n        margin: 0px;\n        border: 0px;   \n        width: 100%;\n    }\n\n    .modal-header table tr td{\n        padding: 10px;\n    \n    }\n    .modal-body{\n        padding-bottom: 20px;\n        margin-left: 20px;\n        margin-right: 20px;\n    }\n\n    .title-element{\n        padding-top: 5px;\n        padding-bottom: 5px;\n    }\n    .modal-content{\n        border-radius: 0px;\n        border: 0px;\n    }\n\n    .modal-header{\n          border-radius: 0;\n    }\n  "],
                    animations: [
                        core_1.trigger('enterAnimation', [
                            core_1.transition(':enter', [
                                core_1.style({ height: '0px', opacity: 0 }),
                                core_1.animate('500ms ease-in', core_1.style({ height: '*', opacity: 0.5 }))
                            ]),
                            core_1.transition(':leave', [
                                core_1.style({ height: '*', opacity: 0.5 }),
                                core_1.animate('300ms ease-out', core_1.style({ height: '0px', opacity: 0 }))
                            ])
                        ]),
                    ],
                },] },
    ];
    /** @nocollapse */
    ResearchGroupLinesListComponent.ctorParameters = function () { return [
        { type: forms_1.FormBuilder, },
        { type: core_1.ChangeDetectorRef, },
        { type: service_locator_1.ServiceLocator, },
        { type: research_group_lines_list_service_1.ResearchGroupLinesListService, },
        { type: core_2.TranslateService, },
        { type: utils_1.TitleCaseAcademiaPipe, },
    ]; };
    ResearchGroupLinesListComponent.propDecorators = {
        "modalDirectiveMulti": [{ type: core_1.ViewChild, args: ['researchgrouplinesdialogmulti',] },],
        "selectFirst": [{ type: core_1.Input },],
        "debugFlag": [{ type: core_1.Input },],
        "readonly": [{ type: core_1.Input },],
        "preSelect": [{ type: core_1.Input, args: ['preSelect',] },],
        "onMultiSelection": [{ type: core_1.Output },],
    };
    return ResearchGroupLinesListComponent;
}());
exports.ResearchGroupLinesListComponent = ResearchGroupLinesListComponent;
//# sourceMappingURL=research.group.lines.list.component.js.map