"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
require("rxjs/add/observable/throw");
var ResearchGroupLinesListService = /** @class */ (function () {
    function ResearchGroupLinesListService(http) {
        this.http = http;
    }
    ResearchGroupLinesListService.prototype.getItems = function (componentModel, idExtRG) {
        var params = new http_1.HttpParams();
        if (componentModel.queryParams) {
            if (idExtRG) {
                componentModel.queryParams = this.changeidExternalRGroup(componentModel.queryParams, "idExternalRGroup", idExtRG);
            }
            componentModel.queryParams.forEach(function (queryParam) { return params = params.append(queryParam.name, queryParam.value); });
            return this.http.get(componentModel.urlService, { params: params })
                .catch(this.handleError);
        }
    };
    ResearchGroupLinesListService.prototype.changeidExternalRGroup = function (queryParams, key, value) {
        var no_exist = true;
        queryParams.map(function (queryParam) {
            if (queryParam.name === key) {
                queryParam.name = key;
                queryParam.value = value;
                no_exist = false;
                return;
            }
        });
        if (no_exist) {
            queryParams.push({ "name": key, "value": value });
        }
        return queryParams;
    };
    ResearchGroupLinesListService.prototype.handleError = function (error) {
        return Observable_1.Observable.throw(error.statusText || 'Server error');
    };
    ResearchGroupLinesListService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ResearchGroupLinesListService.ctorParameters = function () { return [
        { type: http_1.HttpClient, },
    ]; };
    return ResearchGroupLinesListService;
}());
exports.ResearchGroupLinesListService = ResearchGroupLinesListService;
//# sourceMappingURL=research.group.lines.list.service.js.map