"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var animations_1 = require("@angular/animations");
var forms_1 = require("@angular/forms");
var service_locator_1 = require("../../../../service-locator");
var modal_1 = require("ngx-bootstrap/modal");
var search_combo_box_1 = require("../../../../search-combo-box/search-combo-box");
var FormatProductSelectionboxComponent = /** @class */ (function () {
    function FormatProductSelectionboxComponent(_formBuilder, modalService, urlService) {
        this._formBuilder = _formBuilder;
        this.modalService = modalService;
        this.urlService = urlService;
        this.selectedRelationProductFormat = null;
        this.relationProductFormat = {};
        this.selectionProductFormat = {};
        this.selectionFormat = "";
        this.collectionProductFormat = [];
        this.currentOption = "selectionGroup";
        this.optionDefaultFormat = true;
        this.valRelation = -1;
        this.currentIndex = -1;
        this.modalRef = [];
        this.contetBody = [];
        this.debugFlag = false;
        this.onSelection = new core_1.EventEmitter();
        this.formGroup = this._formBuilder.group({
            formatGroupCtrl: ['', forms_1.Validators.compose([])]
        });
        this.formGroupM2 = this._formBuilder.group({
            typeProductCtrl: ['', forms_1.Validators.compose([forms_1.Validators.required])],
            formatGroupCtrl: ['', forms_1.Validators.compose([forms_1.Validators.required])]
        });
        this.selectionProductFormat = new Object();
        this.selectionProductFormat.currentOption = "selectionGroup";
        this.selectionProductFormat.name = "defaultFormat";
        this.selectionProductFormat.return = "default";
    }
    FormatProductSelectionboxComponent.prototype.ngOnInit = function () {
        this.componentModelFormatGroup = new search_combo_box_1.SearchComboBoxGenericModel(this.urlService.getFormatProductsUrl(this.debugFlag), [{ "name": "limit", "value": 5 }], null, "results", "group", "selectFormatGroup");
        this.onSelectionChange();
    };
    FormatProductSelectionboxComponent.prototype.onSelectionChange = function () {
        this.onSelection.emit(this.selectionProductFormat.return);
    };
    FormatProductSelectionboxComponent.prototype.openDialog = function (nivel, contetBody, template) {
        if (nivel == 1) {
            this.relationProductFormat = new Object();
            this.relationProductFormat.productType = {};
            this.relationProductFormat.formatGroup = {};
            this.formGroupM2.reset();
        }
        this.contetBody[nivel] = contetBody;
        this.modalRef[nivel] = this.modalService.show(template);
    };
    FormatProductSelectionboxComponent.prototype.closeDialog = function (nivel) {
        this.modalRef[nivel].hide();
        this.onSelectionChange();
    };
    FormatProductSelectionboxComponent.prototype.selectRelation = function (nivel) {
        if (nivel == 1 && this.valRelation == 1) {
            var returnArray_1 = [];
            this.optionDefaultFormat = false;
            this.selectionFormat = "";
            this.collectionProductFormat.push(this.relationProductFormat);
            this.collectionProductFormat.forEach(function (element) {
                returnArray_1.push(element.productType.id + ";" + element.formatGroup.idFormat);
            });
            this.selectionProductFormat.name = "customFormats";
            this.selectionProductFormat.return = returnArray_1;
        }
        this.onSelectionChange();
        this.modalRef[nivel].hide();
    };
    FormatProductSelectionboxComponent.prototype.onElementChecked = function () {
        this.optionDefaultFormat = !this.optionDefaultFormat;
        if (!this.optionDefaultFormat) {
            this.selectionProductFormat.name = "notFormatsSelected";
            this.selectionProductFormat.return = null;
        }
        else {
            this.selectionProductFormat.name = "defaultFormat";
            this.selectionProductFormat.return = "default";
        }
        this.selectionFormat = "";
        this.collectionProductFormat = [];
        this.selectedRelationProductFormat = null;
        this.relationProductFormat = {};
        this.onSelectionChange();
    };
    FormatProductSelectionboxComponent.prototype.openOption = function (option) {
        this.selectionProductFormat.currentOption = option;
    };
    FormatProductSelectionboxComponent.prototype.setSearchParams = function (type, value, itemControl) {
        if (itemControl === void 0) { itemControl = null; }
        if (value) {
            if (type == 'product-type-M2') {
                this.relationProductFormat.productType = value;
                this.valRelation = 0;
                itemControl.setValue(value);
            }
            else if (type == 'format-group-M2') {
                this.relationProductFormat.formatGroup = value.item;
                this.valRelation = 1;
            }
            else if (type == 'format-group') {
                this.selectionProductFormat.name = value.item.group;
                this.selectionProductFormat.return = value.item.group;
                this.selectionFormat = value.item.group;
                this.optionDefaultFormat = false;
                this.collectionProductFormat = [];
                this.selectedRelationProductFormat = null;
                this.relationProductFormat = {};
                this.onSelectionChange();
            }
        }
    };
    FormatProductSelectionboxComponent.prototype.selectedItem = function (index, item) {
        if (this.currentIndex === -1 || this.currentIndex !== index) {
            this.currentIndex = index;
        }
        else if (this.currentIndex === index) {
            this.currentIndex = -1;
        }
        this.selectedRelationProductFormat = item;
    };
    FormatProductSelectionboxComponent.prototype.goToDelete = function () {
        var _this = this;
        if (this.selectedRelationProductFormat) {
            this.collectionProductFormat.map(function (element, index) {
                if (element.productType.id == _this.selectedRelationProductFormat.productType.id
                    && element.formatGroup.idFormat == _this.selectedRelationProductFormat.formatGroup.idFormat) {
                    _this.collectionProductFormat.splice(index, 1);
                    return;
                }
            });
        }
    };
    FormatProductSelectionboxComponent.prototype.reset = function () {
        this.formGroupM2.reset();
        this.formGroup.reset();
        this.selectionProductFormat = new Object();
        this.selectionProductFormat.currentOption = "selectionGroup";
        this.selectionProductFormat.name = "defaultFormat";
        this.selectionProductFormat.return = "default";
    };
    FormatProductSelectionboxComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-format-product-selectionbox',
                    template: "\n    <div class=\"content-select\">\n      <ul class=\"list-group\">\n        <li class=\"list-group-item item-format\">\n          <div class=\"content-rg\">\n            <div class=\"btn-nodes\">\n              <i class=\"material-icons icon-arrow\">check_circle</i>\n            </div>\n            <div class=\"description-rg\">\n              {{selectionProductFormat.name | translate}}\n            </div>\n            <div class=\"btn-close\">\n              <button type=\"button\" class=\"btn btn-custom\"\n                (click)=\"openDialog(0, bodyFormatProductSelectionBox, formatproductselectiondialog)\">\n                <i class=\"material-icons icons-custom\">loop</i><span class=\"txt-custom\">{{ 'select' | translate}}</span>\n              </button>\n            </div>\n          </div>\n        </li>\n      </ul>\n    </div>\n\n    <!-- Modal del componente relacion de formato y el tipo de producto -->\n    <ng-template #formatproductrelationdialog>\n      <div class=\"fomart-product-selectionbox\">\n        <div class=\"modal-header\">\n          <table class=\"table-list\">\n            <tr>\n              <td>\n                <b>{{'selectFormats' | translate}}</b>\n              </td>\n              <td>\n                <button (click)=\"closeDialog(1)\" type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                  <span aria-hidden=\"true\">&times;</span>\n                </button>\n              </td>\n            </tr>\n          </table>\n        </div>\n        <div align=\"center\" class=\"modal-body\">\n          <ng-container *ngTemplateOutlet=\"contetBody[1]\"></ng-container>\n        </div>\n        <div align=\"center\" class=\"modal-footer\">\n          <button type=\"button\" class=\"btn btn-lg btn-uniandes-main\" [disabled]=\"!formGroupM2.valid\"\n            (click)=\"selectRelation(1)\">{{'select' | translate}}</button>\n            <button type=\"button\" class=\"btn btn-lg btn-uniandes-main\"\n            (click)=\"closeDialog(1)\">{{'cancel' | translate}}</button>\n        </div>\n      </div>\n    </ng-template>\n\n    <!-- Modal del componente seleccion de formato del producto -->\n    <ng-template #formatproductselectiondialog>\n      <div class=\"fomart-product-selectionbox\">\n        <div class=\"modal-header\">\n          <table class=\"table-list\">\n            <tr>\n              <td>\n                <b>{{'selectFormats' | translate}}</b>\n              </td>\n              <td>\n                <button (click)=\"closeDialog(0)\" type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                  <span aria-hidden=\"true\">&times;</span>\n                </button>\n              </td>\n            </tr>\n          </table>\n        </div>\n        <div align=\"center\" class=\"modal-body\">\n          <ng-container *ngTemplateOutlet=\"contetBody[0]\"></ng-container>\n        </div>\n        <div align=\"center\" class=\"modal-footer\">\n          <button type=\"button\" class=\"btn btn-lg btn-uniandes-main\"\n            (click)=\"selectRelation(0)\">{{'close' | translate}}</button>\n        </div>\n      </div>\n    </ng-template>\n\n\n    <!-- Templae del componente seleccion de formato del producto -->\n    <ng-template #bodyFormatProductSelectionBox>\n      <div class=\"List\">\n        <ul class=\"list-group\">\n\n          <li class=\"list-group-item item-fomart\" (click)=\"openOption('selectionGroup')\">\n            <div class=\"content-rg\">\n              <div class=\"chk-rl\">\n                <i\n                  class=\"material-icons icon-arrow\">{{(selectionProductFormat.currentOption === \"selectionGroup\" ? \"check_box\" : \"check_box_outline_blank\")}}</i>\n              </div>\n              <div class=\"description-rl\">\n                {{'selectFormatGroup' | translate}}\n              </div>\n            </div>\n          </li>\n          <div class=\"content-child-session\" *ngIf=\"selectionProductFormat.currentOption === 'selectionGroup'\"\n            [@enterAnimation]>\n            <div class=\"content-select-txt\">\n              <p class=\"txt-select-rg\">{{'selectFormatGroupMsg' | translate}}: </p>\n            </div>\n            <div class=\"content-check\">\n              <div class=\"chk-rl\">\n                <i class=\"material-icons icon-check\"\n                  (click)=\"onElementChecked()\">{{(optionDefaultFormat ? \"check_box\" : \"check_box_outline_blank\")}}</i>\n              </div>\n              <div class=\"description-rl\">\n                {{'useDefaultFormats' | translate}}\n              </div>\n            </div>\n\n            <div class=\"row content-search\">\n              <div class=\"col-xs-12 col-sm-12 col-md-2 col-lg-2\">\n                <label>{{'formatGroup' | translate}}</label>\n              </div>\n              <div class=\"col-xs-12 col-sm-12 col-md-10 col-lg-10\">\n                <app-search-combo-box-generic [componentModel]=\"componentModelFormatGroup\" [preSelectedValue]=\"selectionFormat\" \n                  [itemControl]=\"formGroup.controls.formatGroupCtrl\" (itemSelected)=\"setSearchParams('format-group', $event)\">\n                </app-search-combo-box-generic>\n              </div>\n            </div>\n            <div class=\"row content-center\">\n              <button type=\"button\" (click)=\"selectRelation(0)\" class=\"btn btn-custom\">{{'select' | translate}}</button>\n            </div>\n          </div>\n          <li class=\"list-group-item item-course\" (click)=\"openOption('selectionXProduct')\">\n            <div class=\"content-rg\">\n              <div class=\"chk-rl\">\n                <i\n                  class=\"material-icons icon-arrow\">{{(selectionProductFormat.currentOption === \"selectionXProduct\" ? \"check_box\" : \"check_box_outline_blank\")}}</i>\n              </div>\n              <div class=\"description-rl\">\n                {{'selectFormatsByType' | translate}}\n              </div>\n            </div>\n          </li>\n          <div class=\"content-child-session\" *ngIf=\"selectionProductFormat.currentOption === 'selectionXProduct'\"\n            [@enterAnimation]>\n            <div class=\"content-select-txt\">\n              <p class=\"txt-select-rg\">{{'selectFormatsByTypeMsg' | translate}}: </p>\n            </div>\n            <div class=\"content-table\">\n              <div class=\"right-buttons\">\n                <button type=\"button\" class=\"btn btn-custom\"\n                  (click)=\"openDialog(1, bodyFormatProductRelationBox, formatproductrelationdialog)\">\n                  <i class=\"material-icons icons-custom\">add</i><span class=\"txt-custom\">{{ 'create' | translate}}</span>\n                </button>\n                <button type=\"button\" *ngIf=\"currentIndex > -1\" class=\"btn btn-custom\" (click)=\"goToDelete()\">\n                  <i class=\"material-icons icons-custom\">clear</i><span class=\"txt-custom\">{{ 'delete' | translate}}</span>\n                </button>\n              </div>\n              <table class=\"table\">\n                <thead class=\"thead-light\">\n                  <tr>\n                    <th>{{ 'productType' | translate}}</th>\n                    <th>{{ 'formatGroup' | translate}}</th>\n                  </tr>\n                </thead>\n                <tbody>\n                  <ng-container *ngFor=\"let item of collectionProductFormat; let idx = index \">\n                    <tr (click)=\"selectedItem(idx, item)\" [ngClass]=\"currentIndex === idx ? 'table-selected-uniandes' : ''\">\n                      <td>{{ item.productType.nameid | translate }}</td>\n                      <td>{{ item.formatGroup.group }}</td>\n                    </tr>\n                  </ng-container>\n                  <ng-container *ngIf=\"collectionProductFormat && collectionProductFormat.length === 0\">\n                    <tr>\n                      <td colspan=\"5\">\n                        <p style=\"text-align: center; font-weight: bold;\">{{ 'msnNotFoundRelationProductFormat' | translate}}</p>\n                      </td>\n                    </tr>\n                  </ng-container>\n                </tbody>\n              </table>\n            </div>\n            <div class=\"row content-center\">\n              <button type=\"button\" (click)=\"selectRelation(0)\" class=\"btn btn-custom\">{{'select' | translate}}</button>\n            </div>\n          </div>\n        </ul>\n      </div>\n    </ng-template>\n\n    <!-- Templae del componente relacion entre productos y formatos -->\n    <ng-template #bodyFormatProductRelationBox>\n      <div class=\"content-select-txt\">\n        <p class=\"txt-select-rg-title\">{{'selectFormats' | translate}}</p>\n      </div>\n      <div class=\"content-select-txt\">\n        <p class=\"txt-select-rg\">{{'selectFormatGroupMsg' | translate}}: </p>\n      </div>\n\n      <div class=\"row content-search\">\n        <div class=\"col-xs-12 col-sm-12 col-md-2 col-lg-2\">\n          <label>{{'productType' | translate}}</label>\n        </div>\n        <div class=\"col-xs-12 col-sm-12 col-md-10 col-lg-10\">\n          <app-product-type-combobox [compact]=\"true\" [selectFirst]=\"false\" [multiSelect]=\"false\"\n            (onSelection)=\"setSearchParams('product-type-M2', $event, formGroupM2.controls.typeProductCtrl)\">\n          </app-product-type-combobox>\n        </div>\n      </div>\n      <div class=\"row content-search\">\n        <div class=\"col-xs-12 col-sm-12 col-md-2 col-lg-2\">\n          <label>{{'formatGroup' | translate}}</label>\n        </div>\n        <div class=\"col-xs-12 col-sm-12 col-md-10 col-lg-10\">\n          <app-search-combo-box-generic [componentModel]=\"componentModelFormatGroup\"\n            [itemControl]=\"formGroupM2.controls.formatGroupCtrl\" (itemSelected)=\"setSearchParams('format-group-M2', $event)\">\n          </app-search-combo-box-generic>\n        </div>\n      </div>\n    </ng-template>\n  ",
                    styles: ["\n    .content-select {\n      margin-bottom: 10px;\n    }\n\n    .content-select .item-format,\n    .fomart-product-selectionbox .item-format {\n      padding: 0.4rem 0.5rem;\n      cursor: pointer;\n    }\n\n    .content-select .content-rg,\n    .fomart-product-selectionbox .content-rg {\n      display: flex;\n      align-content: center;\n      cursor: pointer;\n    }\n\n    .content-select .btn-nodes {\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex: 0 0 5%;\n      order: 1;\n    }\n\n    .content-select .btn-close {\n      flex: 0 0 20%;\n      order: 4;\n      margin-left: auto;\n    }\n\n    .content-select .description-rg {\n      flex: 0 0 auto;\n      order: 3;\n      display: flex;\n      text-align: left;\n      align-items: center;\n      font-size: 0.9rem;\n      padding-right: 0.4rem;\n      padding-left: 0.4rem;\n    }\n\n    .fomart-product-selectionbox .chk-rl {\n      flex: 0 0 3%;\n      order: 2;\n      padding-left: 0.5rem;\n    }\n\n    .fomart-product-selectionbox .description-rl {\n      flex: 0 0 97%;\n      order: 3;\n      margin-top: 0.2rem;\n      text-align: left;\n      font-weight: 500;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      padding-right: 0.2rem;\n      padding-left: 0.2rem;\n      cursor: pointer;\n    }\n\n    .fomart-product-selectionbox .content-select-txt {\n      padding: 0.1rem 1rem;\n    }\n\n    .fomart-product-selectionbox .content-select-txt .txt-select-rg {\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      margin: 0.5rem 0.2rem;\n      text-align: left;\n    }\n\n    .fomart-product-selectionbox .content-select-txt .txt-select-rg-title {\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n      font-weight: 700;\n      margin: 0.5rem 0.2rem;\n      text-align: left;\n    }\n\n    .fomart-product-selectionbox .content-child-session {\n      padding: 2px;\n      border: 1px solid #dee2e6;\n      border-radius: 2px;\n    }\n\n    .fomart-product-selectionbox .check-function {\n      float: left;\n      position: relative;\n      margin-top: 5px;\n    }\n\n    .fomart-product-selectionbox .icon-check {\n      font-size: 1.4rem;\n      float: left;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .fomart-product-selectionbox .content-check {\n      display: flex;\n      align-content: center;\n      padding: 0.5rem 1rem;\n    }\n\n    .fomart-product-selectionbox .content-search {\n      align-content: center;\n      padding: 0.5rem 1.5rem;\n      font-weight: 500;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n    }\n\n    .fomart-product-selectionbox .content-center {\n      justify-content: center;\n      display: flex;\n      padding: 0.5rem 1.5rem;\n      font-weight: 500;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n    }\n\n    .fomart-product-selectionbox .content-search label {\n      display: inline-block;\n      margin-bottom: 0.5rem;\n      margin-top: 0.5rem;\n    }\n\n    .fomart-product-selectionbox .table {\n      width: 100%;\n      max-width: 100%;\n      margin-bottom: 20px;\n      font-weight: 500;\n      line-height: 0.9rem;\n      font-size: 0.9rem;\n    }\n\n    .fomart-product-selectionbox .content-table {\n      margin: 0rem 1rem;\n    }\n\n    .fomart-product-selectionbox .right-buttons {\n      display: flex;\n      justify-content: flex-end;\n      margin: 0.5rem 0rem;\n    }\n\n    .content-select .btn-custom:hover,\n    .fomart-product-selectionbox .btn-custom:hover {\n      color: #39350a;\n      background-color: #ffff20;\n      border-color: #ffff20;\n    }\n\n    .content-select .btn-custom {\n      float: right;\n    }\n\n    .content-select .btn-custom,\n    .fomart-product-selectionbox .btn-custom {\n      display: flex;\n      color: #39350a;\n      padding: 0.2rem 0.5rem;\n      margin-left: 0.3rem;\n    }\n\n    .content-select .icons-custom,\n    .fomart-product-selectionbox .icons-custom {\n      display: inline-flex;\n    }\n\n    .content-select .txt-custom,\n    .fomart-product-selectionbox .txt-custom {\n      display: inline-flex;\n    }\n\n    .table-selected-uniandes th,\n    .table-selected-uniandes td,\n    .table-selected-uniandes thead th,\n    .table-selected-uniandes tbody + tbody {\n      border-color: #ffff20;\n    }\n\n    .table-selected-uniandes,\n    .table-selected-uniandes > th,\n    .table-selected-uniandes > td {\n      background-color: #ffff20;\n    }\n\n    .fomart-product-selectionbox .modal-header {\n      padding: 0px;\n      border: 0px;\n      background-color: #ffff00;\n    }\n\n    .fomart-product-selectionbox .modal-header table {\n      margin: 0px;\n      border: 0px;\n      width: 100%;\n    }\n\n    .fomart-product-selectionbox .modal-header .close {\n      padding: 1rem;\n      margin: -1rem -1rem -1rem auto;\n    }\n\n    .fomart-product-selectionbox .close {\n      float: right;\n      font-size: 1.5rem;\n      font-weight: 700;\n      line-height: 1;\n      color: #000;\n      text-shadow: 0 1px 0 #fff;\n      opacity: 0.5;\n    }\n\n    .fomart-product-selectionbox .close:not(:disabled):not(.disabled) {\n      cursor: pointer;\n    }\n\n    .fomart-product-selectionbox button.close {\n      padding: 0;\n      background-color: transparent;\n      border: 0;\n      -webkit-appearance: none;\n    }\n\n    .fomart-product-selectionbox .modal-header table tr td {\n      padding: 10px;\n    }\n\n    .fomart-product-selectionbox .modal-footer {\n      display: block;\n      padding: 10px;\n    }\n\n    .btn-uniandes-main:hover,\n    .btn-uniandes-main:focus,\n    .btn-uniandes-main:active,\n    .btn-uniandes-main.active {\n      color: #000000;\n      background-color: #ffff20;\n      border-color: none;\n    }\n  "],
                    animations: [
                        animations_1.trigger('enterAnimation', [
                            animations_1.transition(':enter', [
                                animations_1.style({ height: '0px', opacity: 0 }),
                                animations_1.animate('500ms ease-in', animations_1.style({ height: '*', opacity: 0.5 }))
                            ]),
                            animations_1.transition(':leave', [
                                animations_1.style({ height: '*', opacity: 0.5 }),
                                animations_1.animate('300ms ease-out', animations_1.style({ height: '0px', opacity: 0 }))
                            ])
                        ]),
                    ],
                },] },
    ];
    /** @nocollapse */
    FormatProductSelectionboxComponent.ctorParameters = function () { return [
        { type: forms_1.FormBuilder, },
        { type: modal_1.BsModalService, },
        { type: service_locator_1.ServiceLocator, },
    ]; };
    FormatProductSelectionboxComponent.propDecorators = {
        "debugFlag": [{ type: core_1.Input },],
        "onSelection": [{ type: core_1.Output },],
    };
    return FormatProductSelectionboxComponent;
}());
exports.FormatProductSelectionboxComponent = FormatProductSelectionboxComponent;
//# sourceMappingURL=format.product.selectionbox.component.js.map