"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var combo_box_1 = require("../../../../combo-box/combo-box");
var combo_box_modeldata_1 = require("../../../../combo-box/model-data/combo-box.modeldata");
var YearComboBoxComponent = /** @class */ (function (_super) {
    __extends(YearComboBoxComponent, _super);
    function YearComboBoxComponent() {
        return _super.call(this) || this;
    }
    YearComboBoxComponent.prototype.ngOnInit = function () {
        this.setData();
    };
    YearComboBoxComponent.prototype.setData = function () {
        var _this = this;
        this.data = [];
        var bruteData = this.getYearsFromDate(this.yearsToBack);
        this.selectionParamsBeforeReset();
        bruteData.forEach(function (element) {
            var nmodeldata = new combo_box_modeldata_1.ComboBoxModelData(false, false, true, element.nameid, element);
            _this.data.push(nmodeldata);
        });
        this.selectionParamsAfterReset();
    };
    YearComboBoxComponent.prototype.getYearsFromDate = function (size) {
        if (size === void 0) { size = 20; }
        var today = new Date();
        var currentYear = today.getFullYear();
        var arrayYears = [];
        while (size >= -1) {
            arrayYears.push({ 'nameid': (currentYear - size).toString(), 'value': currentYear - size });
            size--;
        }
        return arrayYears.reverse();
    };
    YearComboBoxComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-year-combo-box',
                    template: "\n    <div>\n        <select [disabled]=\"disabled\" id=\"yearscombobox\" [(ngModel)]=\"selectedSingle\" class=\"combobox form-control\" (change)=\"onSelectionChange()\">\n          <option [(hidden)]=\"element.hidden\" *ngFor=\"let element of data\" [ngValue]=\"element\">{{(element.object == null ? 'UNASIGNED':element.object.nameid)| translate }}</option>\n        </select>\n    </div>\n  ",
                    styles: ["\n\n  "]
                },] },
    ];
    /** @nocollapse */
    YearComboBoxComponent.ctorParameters = function () { return []; };
    YearComboBoxComponent.propDecorators = {
        "yearsToBack": [{ type: core_1.Input },],
    };
    return YearComboBoxComponent;
}(combo_box_1.ComboBox));
exports.YearComboBoxComponent = YearComboBoxComponent;
//# sourceMappingURL=year-combo-box.component.js.map