import { OnInit, EventEmitter } from '@angular/core';
import { CrudCompactComponent } from '../crud-compact.component';
import { FormBuilder } from '@angular/forms';
import { AcademiaPaginationService } from '../../academia-pagination/academia-pagination';
import { TranslateService } from '@ngx-translate/core';
import { CrudCompactService } from '../crud-compact.service';
export declare class AdvisorCompactComponent extends CrudCompactComponent implements OnInit {
    _formBuilder: FormBuilder;
    paginationService: AcademiaPaginationService;
    translate: TranslateService;
    crudCompactService: CrudCompactService;
    /**
     *  input inner advisors to component
     */
    advisors: any[];
    debugFlag: boolean;
    /**
     *  output external advisors to parent component
     */
    updatedAdvisors: EventEmitter<any>;
    /**
    * Constructor for the advisor-compact component
    * @param _formBuilder Form Builder for creating Reactive Forms group.
    * @param paginationService Academia Pagination Service for client pagination.
    * @param translate Translate service for translating keys inside component
    */
    constructor(_formBuilder: FormBuilder, paginationService: AcademiaPaginationService, translate: TranslateService, crudCompactService: CrudCompactService);
    ngOnInit(): void;
    private addAdvisors(advisors);
    setNewItem(): void;
    deleteItem(itemForDeleting: any): void;
    getPersonType(item: any): any;
}
