import { OnInit, ChangeDetectorRef, EventEmitter, ElementRef } from '@angular/core';
import { FileUploader } from 'ng2-file-upload';
import { FileSelectService } from './file-select.service';
import { TranslateService } from '@ngx-translate/core';
import { DomSanitizer } from '@angular/platform-browser';
import { ImageCropperComponent, CropperSettings } from 'ng2-img-cropper';
export declare class FileSelectComponent extends FileUploader implements OnInit {
    cd: ChangeDetectorRef;
    private fileService;
    private translate;
    private sanitizer;
    fileSelectId: number;
    downloadFileList: any[];
    disableDownload: boolean;
    disableUpload: boolean;
    title: string;
    imageThumbnailHeight: number;
    otherParameters: any[];
    readonly getOtherParameters: any[];
    setOtherParameters: any;
    uploadServiceUrl: any;
    readonly getUploadServiceUrl: string;
    setUploadServiceUrl: string;
    downloadServiceUrl: any;
    readonly getDownloadServiceUrl: string;
    setDownloadServiceUrl: string;
    deleteServiceUrl: any;
    readonly getDeleteServiceUrl: string;
    setDeleteServiceUrl: string;
    downloadListServiceUrl: any;
    readonly getDownloadListServiceUrl: string;
    setDownloadListServiceUrl: string;
    maxFiles: number;
    cropperWidth: number;
    cropperHeight: number;
    cropperOutWidth: number;
    cropperOutHeight: number;
    extensionsList: any[];
    maxFileSize: number;
    downloadOnly: boolean;
    singleRequestUpload: boolean;
    onFileUploadSuccess: EventEmitter<{}>;
    onFileUploadError: EventEmitter<{}>;
    onSingleRequestUploadSuccess: EventEmitter<{}>;
    onSingleRequestUploadError: EventEmitter<{}>;
    onFileDeleteSuccess: EventEmitter<{}>;
    onFileDeleteError: EventEmitter<{}>;
    onFileListUpdate: EventEmitter<{}>;
    uplder: ElementRef;
    uploaderState: number;
    isFileOvesized: boolean;
    isFileQueueFull: boolean;
    isFileInvalid: boolean;
    imgCropper: ImageCropperComponent;
    cropperSettings: CropperSettings;
    currentImage: any;
    cropperActive: boolean;
    constructor(cd: ChangeDetectorRef, fileService: FileSelectService, translate: TranslateService, sanitizer: DomSanitizer, document: any);
    isFileAnImage(file: any): boolean;
    refreshUploaderOptions(): void;
    switchAllItemsToErrorSingleRequest(response: any): void;
    switchAllItemsToDownloadedSingleRequest(response: any): void;
    switchUploadedToDownloaded(item: any): void;
    getUploadProgress(): number;
    openUploadDialog(): void;
    isFileExtensionValid(filename: any): boolean;
    getExtensionsString(): string;
    correctFileUpload(data: any): void;
    errorFileUpload(data: any): void;
    deleteFileSuccess(data: any): void;
    deleteFileError(data: any): void;
    singleRequestUploadSuccess(data: any): void;
    singleRequestUploadError(data: any): void;
    fileListUpdate(data: any): void;
    resetFileStates(): void;
    removeAllPendingFiles(): void;
    uploadFiles(): void;
    ngOnInit(): void;
    round(x: any, n: any): number;
    uploadAllSingleRequest(): void;
    downloadFile(item: any): void;
    getFileList(): void;
    deleteFile(item: any): void;
    setImageThmbFromFile(item: any): void;
    cropImage(): void;
    openImageCropper(item: any): void;
    dataURLtoBlob(dataurl: any): Blob;
    closeImageCropper(): void;
}
