"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ng2_file_upload_1 = require("ng2-file-upload");
var file_select_service_1 = require("./file-select.service");
var core_2 = require("@ngx-translate/core");
var platform_browser_1 = require("@angular/platform-browser");
var ng2_img_cropper_1 = require("ng2-img-cropper");
var common_1 = require("@angular/common");
var sweetalert2_1 = require("sweetalert2");
var FileSelectComponent = /** @class */ (function (_super) {
    __extends(FileSelectComponent, _super);
    function FileSelectComponent(cd, fileService, translate, sanitizer, document) {
        var _this = _super.call(this, {}) || this;
        _this.cd = cd;
        _this.fileService = fileService;
        _this.translate = translate;
        _this.sanitizer = sanitizer;
        _this.fileSelectId = 0;
        _this.downloadFileList = [];
        _this.disableDownload = false;
        _this.disableUpload = false;
        _this.title = "";
        _this.imageThumbnailHeight = 100;
        _this.otherParameters = [];
        _this.uploadServiceUrl = null;
        _this.downloadServiceUrl = null;
        _this.deleteServiceUrl = null;
        _this.downloadListServiceUrl = null;
        _this.maxFiles = 1;
        _this.cropperWidth = 500;
        _this.cropperHeight = 300;
        _this.cropperOutWidth = 500;
        _this.cropperOutHeight = 500;
        _this.extensionsList = [];
        _this.maxFileSize = 100000;
        _this.downloadOnly = false;
        _this.singleRequestUpload = false;
        //Events (All Syncronic for easier server url changing)
        _this.onFileUploadSuccess = new core_1.EventEmitter(false);
        _this.onFileUploadError = new core_1.EventEmitter(false);
        _this.onSingleRequestUploadSuccess = new core_1.EventEmitter(false);
        _this.onSingleRequestUploadError = new core_1.EventEmitter(false);
        _this.onFileDeleteSuccess = new core_1.EventEmitter(false);
        _this.onFileDeleteError = new core_1.EventEmitter(false);
        _this.onFileListUpdate = new core_1.EventEmitter(false);
        _this.uploaderState = 0;
        _this.isFileOvesized = false;
        _this.isFileQueueFull = false;
        _this.isFileInvalid = false;
        _this.cropperActive = false;
        _this.cropperSettings = new ng2_img_cropper_1.CropperSettings();
        _this.cropperSettings.width = _this.cropperOutWidth;
        _this.cropperSettings.height = _this.cropperOutHeight;
        _this.cropperSettings.croppedWidth = _this.cropperOutWidth;
        _this.cropperSettings.croppedHeight = _this.cropperOutHeight;
        _this.cropperSettings.canvasWidth = _this.cropperWidth;
        _this.cropperSettings.canvasHeight = _this.cropperHeight;
        _this.cropperSettings.noFileInput = true;
        _this.onAfterAddingFile = function (item) {
            if (_this.isFileAnImage(item)) {
                _this.setImageThmbFromFile(item);
            }
            if (!_this.isFileExtensionValid(item.file.name)) {
                _this.isFileInvalid = true;
                item.remove();
                // Verify File Size
            }
            else if (item.file.size > _this.maxFileSize) {
                _this.isFileOvesized = true;
                item.remove();
                //Verify File count
            }
            else if ((_this.queue.length + _this.downloadFileList.length) > _this.maxFiles) {
                _this.isFileQueueFull = true;
                item.remove();
            }
            cd.detectChanges();
        };
        _this.onBeforeUploadItem = function (item) {
            cd.detectChanges();
        };
        _this.onCompleteAll = function () {
            _this.uploaderState = 1;
            cd.detectChanges();
        };
        _this.onCompleteItem = function (item) {
            cd.detectChanges();
        };
        _this.onSuccessItem = function (item, response) {
            _this.correctFileUpload(JSON.parse(response));
            cd.detectChanges();
            _this.switchUploadedToDownloaded(item);
            cd.detectChanges();
        };
        _this.onErrorItem = function (item, response) {
            _this.errorFileUpload(response);
            _this.uploaderState = 2;
            cd.detectChanges();
        };
        return _this;
    }
    Object.defineProperty(FileSelectComponent.prototype, "getOtherParameters", {
        get: function () {
            return this.otherParameters;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "setOtherParameters", {
        set: function (value) {
            this.otherParameters = value;
            this.refreshUploaderOptions();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "getUploadServiceUrl", {
        get: function () {
            return this.uploadServiceUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "setUploadServiceUrl", {
        set: function (value) {
            this.uploadServiceUrl = value;
            this.refreshUploaderOptions();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "getDownloadServiceUrl", {
        get: function () {
            return this.downloadServiceUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "setDownloadServiceUrl", {
        set: function (value) {
            this.downloadServiceUrl = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "getDeleteServiceUrl", {
        get: function () {
            return this.deleteServiceUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "setDeleteServiceUrl", {
        set: function (value) {
            this.deleteServiceUrl = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "getDownloadListServiceUrl", {
        get: function () {
            return this.downloadListServiceUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileSelectComponent.prototype, "setDownloadListServiceUrl", {
        set: function (value) {
            this.downloadListServiceUrl = value;
        },
        enumerable: true,
        configurable: true
    });
    //========================= PRIVATE METHODS =========================
    //========================= PRIVATE METHODS =========================
    FileSelectComponent.prototype.isFileAnImage = 
    //========================= PRIVATE METHODS =========================
    function (file) {
        var type = file.file.rawFile.type;
        if (type.toLowerCase().includes('image')) {
            return true;
        }
        return false;
    };
    FileSelectComponent.prototype.refreshUploaderOptions = function () {
        this.setOptions({ url: this.uploadServiceUrl, additionalParameter: this.otherParameters });
    };
    FileSelectComponent.prototype.switchAllItemsToErrorSingleRequest = function (response) {
        this.queue.forEach(function (element) {
            element.isReady = false;
            element.isUploading = false;
            element.isUploaded = false;
            element.isSuccess = false;
            element.isCancel = false;
            element.isError = true;
        });
        this.cd.detectChanges();
        this.singleRequestUploadError(response);
        this.cd.detectChanges();
    };
    FileSelectComponent.prototype.switchAllItemsToDownloadedSingleRequest = function (response) {
        this.queue = [];
        this.cd.detectChanges();
        this.singleRequestUploadSuccess(response);
        this.cd.detectChanges();
        this.getFileList();
    };
    FileSelectComponent.prototype.switchUploadedToDownloaded = function (item) {
        item.remove();
        this.getFileList();
    };
    FileSelectComponent.prototype.getUploadProgress = function () {
        var uploaded = 0;
        this.queue.forEach(function (element) {
            if (element.isUploaded) {
                uploaded++;
            }
        });
        return (uploaded / this.queue.length) * 100;
    };
    FileSelectComponent.prototype.openUploadDialog = function () {
        var event = new MouseEvent('click', { bubbles: false });
        this.uplder.nativeElement.dispatchEvent(event);
        this.isFileOvesized = false;
        this.isFileQueueFull = false;
        this.isFileInvalid = false;
    };
    FileSelectComponent.prototype.isFileExtensionValid = function (filename) {
        var ext = filename.split('.').pop();
        for (var i = 0; i < this.extensionsList.length; i++) {
            if (this.extensionsList[i].toLowerCase() === ext.toLowerCase()) {
                return true;
            }
        }
        return false;
    };
    FileSelectComponent.prototype.getExtensionsString = function () {
        var str = "";
        var i = 0;
        this.extensionsList.forEach(function (element) {
            str += ((i == 0 ? "" : ", ") + element);
            i++;
        });
        return str;
    };
    //================== PUBLIC METHODS======================
    //================== PUBLIC METHODS======================
    FileSelectComponent.prototype.correctFileUpload = 
    //================== PUBLIC METHODS======================
    function (data) {
        this.onFileUploadSuccess.emit(data);
    };
    FileSelectComponent.prototype.errorFileUpload = function (data) {
        this.onFileUploadError.emit(data);
    };
    FileSelectComponent.prototype.deleteFileSuccess = function (data) {
        this.onFileDeleteSuccess.emit(data);
    };
    FileSelectComponent.prototype.deleteFileError = function (data) {
        this.onFileDeleteError.emit(data);
    };
    FileSelectComponent.prototype.singleRequestUploadSuccess = function (data) {
        this.onSingleRequestUploadSuccess.emit(data);
    };
    FileSelectComponent.prototype.singleRequestUploadError = function (data) {
        this.onSingleRequestUploadError.emit(data);
    };
    FileSelectComponent.prototype.fileListUpdate = function (data) {
        this.onFileListUpdate.emit(data);
    };
    FileSelectComponent.prototype.resetFileStates = function () {
        this.queue.forEach(function (element) {
            element.isReady = true;
            element.isUploading = false;
            element.isUploaded = false;
            element.isSuccess = false;
            element.isCancel = false;
            element.isError = false;
        });
        this.isFileOvesized = false;
        this.isFileQueueFull = false;
        this.isFileInvalid = false;
    };
    FileSelectComponent.prototype.removeAllPendingFiles = function () {
        this.queue = [];
        this.resetFileStates();
    };
    FileSelectComponent.prototype.uploadFiles = function () {
        this.resetFileStates();
        this.uploaderState = 0;
        if (this.singleRequestUpload) {
            this.uploadAllSingleRequest();
        }
        else {
            this.uploadAll();
        }
    };
    FileSelectComponent.prototype.ngOnInit = function () {
        this.setOptions({ url: this.uploadServiceUrl });
        this.getFileList();
    };
    FileSelectComponent.prototype.round = function (x, n) {
        return Math.round(x * Math.pow(10, n)) / Math.pow(10, n);
    };
    //================= UPLOAD METHODS=======================
    //================= UPLOAD METHODS=======================
    FileSelectComponent.prototype.uploadAllSingleRequest = 
    //================= UPLOAD METHODS=======================
    function () {
        var _this = this;
        var xhr = new XMLHttpRequest();
        var sendable = new FormData();
        var fakeitem = null;
        this.onBuildItemForm(fakeitem, sendable);
        for (var _b = 0, _c = this.queue; _b < _c.length; _b++) {
            var item = _c[_b];
            item.isReady = true;
            item.isUploading = true;
            item.isUploaded = false;
            item.isSuccess = false;
            item.isCancel = false;
            item.isError = false;
            item.progress = 0;
            if (typeof item._file.size !== 'number') {
                throw new TypeError('The file specified is no longer valid');
            }
            sendable.append("files", item._file, item.file.name);
        }
        if (this.options.additionalParameter !== undefined) {
            Object.keys(this.options.additionalParameter).forEach(function (key) {
                sendable.append(key, _this.options.additionalParameter[key]);
            });
        }
        xhr.onload = function (response) {
            var gist = (xhr.status >= 200 && xhr.status < 300) || xhr.status === 304 ? 'Success' : 'Error';
            if (gist == "Error") {
                _this.switchAllItemsToErrorSingleRequest(xhr.response);
            }
            else {
                _this.switchAllItemsToDownloadedSingleRequest(xhr.response);
            }
        };
        xhr.onerror = function () {
            _this.onErrorItem(fakeitem, null, xhr.status, null);
        };
        xhr.onabort = function () {
            _this.onErrorItem(fakeitem, null, xhr.status, null);
        };
        xhr.open("POST", this.options.url, true);
        xhr.withCredentials = true;
        if (this.options.headers) {
            for (var _i = 0, _a = this.options.headers; _i < _a.length; _i++) {
                var header = _a[_i];
                xhr.setRequestHeader(header.name, header.value);
            }
        }
        if (this.authToken) {
            xhr.setRequestHeader(this.authTokenHeader, this.authToken);
        }
        xhr.send(sendable);
    };
    ;
    //=====================DOWNLOAD METHODS===========================
    //=====================DOWNLOAD METHODS===========================
    FileSelectComponent.prototype.downloadFile = 
    //=====================DOWNLOAD METHODS===========================
    function (item) {
        var _this = this;
        if (this.downloadServiceUrl != null) {
            this.fileService.downloadFile(this.downloadServiceUrl, item).subscribe(function (success) {
                var a = document.createElement("a");
                a.href = URL.createObjectURL(success);
                a.download = item.name;
                // start download
                a.click();
            }, function (error) {
                sweetalert2_1.default({
                    type: 'error',
                    title: _this.translate.instant('errorMessage'),
                    text: _this.translate.instant("" + error.error)
                });
            });
        }
    };
    //========================= DOWNLOAD LIST METHODS===================
    //========================= DOWNLOAD LIST METHODS===================
    FileSelectComponent.prototype.getFileList = 
    //========================= DOWNLOAD LIST METHODS===================
    function () {
        var _this = this;
        if (this.downloadListServiceUrl != null) {
            this.downloadFileList = [];
            this.fileService.getDownloadFileList("" + this.downloadListServiceUrl).subscribe(function (success) {
                if (success != null) {
                    if (success.files) {
                        success.files.forEach(function (element) {
                            _this.downloadFileList.push(element);
                        });
                    }
                    else {
                        _this.downloadFileList.push(success);
                    }
                }
                _this.fileListUpdate(success);
                _this.cd.detectChanges();
            }, function (error) {
                sweetalert2_1.default({
                    type: 'error',
                    title: _this.translate.instant('errorMessage'),
                    text: _this.translate.instant(error.message)
                });
            });
        }
    };
    //============================= DELETE METHODS =============================
    //============================= DELETE METHODS =============================
    FileSelectComponent.prototype.deleteFile = 
    //============================= DELETE METHODS =============================
    function (item) {
        var _this = this;
        if (this.deleteServiceUrl != null) {
            var titleObs = this.translate.instant('areYouSure');
            var textObs = this.translate.instant('noRevert');
            var confirmButtonTextObs = this.translate.instant('yesDelete');
            var declineButtonTextObs = this.translate.instant('cancel');
            sweetalert2_1.default({
                title: titleObs,
                text: textObs,
                type: 'warning',
                showCancelButton: true,
                confirmButtonText: confirmButtonTextObs,
                cancelButtonText: declineButtonTextObs
            }).then(function (result) {
                if (result.value) {
                    _this.fileService.deleteFile(_this.deleteServiceUrl, item).subscribe(function (success) {
                        _this.deleteFileSuccess(success);
                        _this.cd.detectChanges();
                        _this.getFileList();
                    }, function (error) {
                        _this.deleteFileError(error);
                        sweetalert2_1.default({
                            type: 'error',
                            title: _this.translate.instant('deleteErrorMessage'),
                            text: _this.translate.instant(error.message)
                        });
                    });
                }
            });
        }
    };
    //================== IMAGE CROPPER ===================
    //================== IMAGE CROPPER ===================
    FileSelectComponent.prototype.setImageThmbFromFile = 
    //================== IMAGE CROPPER ===================
    function (item) {
        var _this = this;
        var idx = this.queue.indexOf(item);
        var nimage = new Image();
        var file = item.file.rawFile;
        var myReader = new FileReader();
        myReader.onloadend = function (loadEvent) {
            nimage.src = loadEvent.target.result;
            var imgThumb = document.getElementById("imgthfileselect" + _this.fileSelectId + "" + idx);
            imgThumb.setAttribute("src", nimage.src);
        };
        myReader.readAsDataURL(file);
    };
    FileSelectComponent.prototype.cropImage = function () {
        var img = this.imgCropper.image;
        this.currentImage.file.rawFile = this.dataURLtoBlob(img.image);
        this.currentImage._file = this.dataURLtoBlob(img.image);
        this.setImageThmbFromFile(this.currentImage);
        this.cropperActive = false;
    };
    FileSelectComponent.prototype.openImageCropper = function (item) {
        var image = new Image();
        var file = item.some;
        var reader = new FileReader();
        var that = this;
        this.currentImage = item;
        reader.onloadend = function (loadEvent) {
            image.src = loadEvent.target.result;
            that.imgCropper.setImage(image);
        };
        reader.readAsDataURL(file);
        this.cropperActive = true;
    };
    //Tomado de https://stackoverflow.com/questions/28041840/convert-dataurl-to-file-using-javascript
    //Tomado de https://stackoverflow.com/questions/28041840/convert-dataurl-to-file-using-javascript
    FileSelectComponent.prototype.dataURLtoBlob = 
    //Tomado de https://stackoverflow.com/questions/28041840/convert-dataurl-to-file-using-javascript
    function (dataurl) {
        var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1], bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
        while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
        }
        return new Blob([u8arr], { type: mime });
    };
    FileSelectComponent.prototype.closeImageCropper = function () {
        this.setImageThmbFromFile(this.currentImage);
        this.cropperActive = false;
    };
    FileSelectComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-file-select',
                    template: "\n    <div class=\"table-responsive\">\n        <div class=\"file-top borders\">\n            <div> {{title}} </div>\n            <div *ngIf=\"!downloadOnly\" class=\"cell-center-align\"> {{'extList' | translate}}{{\": \"+getExtensionsString()}}</div>\n            <div *ngIf=\"!downloadOnly\" class=\"cell-center-align\">\n            {{'fileMaxSize' | translate}}{{\": \"+round(maxFileSize/1024,1)}} KB </div>\n            <div class=\"cell-center-align\"> {{(queue.length + downloadFileList.length)}}&nbsp;{{'fileNumber' | translate}}&nbsp; {{maxFiles}} </div>\n            <div class=\"cell-center-align\"\n                *ngIf=\"!downloadOnly\">\n                <input hidden type=\"file\" #uplder ng2FileSelect [uploader]=\"this\" multiple />\n                <button type=\"button\" class=\"btn btn-uniandes-main\" (click)=\"openUploadDialog()\">\n                    <i class=\"material-icons\">add</i>\n                </button>\n            </div>\n        </div>\n        <div *ngIf=\"isFileOvesized || isFileQueueFull || isFileInvalid\" align=\"center\" class=\"alert alert-danger alert-borderless\">\n            <ul>\n                <li *ngIf=\"isFileOvesized\">{{'maximumSizeExceeded' | translate}} </li>\n                <li *ngIf=\"isFileQueueFull\">{{'queueFull' | translate}} </li>\n                <li *ngIf=\"isFileInvalid\">{{'extensionInvalid' | translate}} </li>\n            </ul>\n        </div>\n        <div *ngIf=\"!downloadOnly\">\n            <div class=\"progress\">\n                <div class=\"progress-bar\" role=\"progressbar\" [style.width]=\" getUploadProgress() + '%'\" [style.background-color]=\"uploaderState==1?'#FFF200':'darkgray'\"></div>\n            </div>\n        </div>\n        <div *ngIf=\"!cropperActive\">\n            <div *ngFor=\"let item of queue\">\n                <div *ngIf=\"!isFileAnImage(item)\" class=\"file-row borders\">\n                    <div>{{item.file.name}}</div>\n                    <div class=\"cell-center-align\"> {{ round(item.file.size/1024,1)}} KB </div>\n                    <div class=\"cell-center-align\">\n                        <span *ngIf=\"item.isCancel\">\n                            <i class=\"material-icons\">not_interested</i>\n                        </span>\n                        <span *ngIf=\"item.isError\">\n                            <i class=\"material-icons\" style=\"color: red;\">error</i>\n                        </span>\n                        <span *ngIf=\"!item.isSuccess && !item.isCancel && !item.isError && !item.isUploading\">\n                            <i class=\"material-icons\">hourglass_empty</i>\n                        </span>\n                        <div *ngIf=\"item.isUploading\" class=\"lds-fil\">\n                            <div></div>\n                            <div></div>\n                            <div></div>\n                        </div>\n                    </div>\n                    <div class=\"cell-center-align\">\n                        <button type=\"button\" class=\"btn-default-transparent\" [disabled]=\"isUploading\" (click)=\"item.remove()\">\n                            <i class=\"material-icons\">clear</i>\n                        </button>\n                    </div>\n                </div>\n                <div *ngIf=\"isFileAnImage(item)\" class=\"file-row-img borders\">\n                    <div class=\"cell-center-align\">\n                        <img [id]=\"'imgthfileselect'+fileSelectId+''+queue.indexOf(item)\" src=\"\" class=\"imgThmb\" [height]=\"imageThumbnailHeight\"> </div>\n                    <div class=\"cell-center-align\">{{item.file.name}}</div>\n                    <div class=\"cell-center-align\"> {{ round(item.file.size/1024,1)}} KB </div>\n                    <div class=\"cell-center-align\">\n                        <span *ngIf=\"item.isCancel\">\n                            <i class=\"material-icons\">not_interested</i>\n                        </span>\n                        <span *ngIf=\"item.isError\">\n                            <i class=\"material-icons\" style=\"color: red;\">error</i>\n                        </span>\n                        <span *ngIf=\"!item.isSuccess && !item.isCancel && !item.isError && !item.isUploading\">\n                            <i class=\"material-icons\">hourglass_empty</i>\n                        </span>\n                        <div *ngIf=\"item.isUploading\" class=\"lds-fil\">\n                            <div></div>\n                            <div></div>\n                            <div></div>\n                        </div>\n                    </div>\n                    <div class=\"cell-center-align\">\n                        <button type=\"button\" class=\"btn-default-transparent\" [disabled]=\"isUploading\" (click)=\"openImageCropper(item)\">\n                            <i class=\"material-icons\">crop</i>\n                        </button>\n                    </div>\n                    <div class=\"cell-center-align\">\n                        <button type=\"button\" class=\"btn-default-transparent\" [disabled]=\"isUploading\" (click)=\"item.remove()\">\n                            <i class=\"material-icons\">clear</i>\n                        </button>\n                    </div>\n                </div>\n            </div>\n            <div class=\"file-bottom borders\" *ngIf=\"queue.length && !downloadOnly && !cropperActive\">\n                <button type=\"button\" class=\"btn btn-uniandes-main btn-s\" [disabled]=\"isUploading\" (click)=\"uploadFiles()\">\n                    <i class=\"material-icons\">cloud_upload</i>&nbsp;{{'uploadAll' | translate}}\n                </button>\n                <button type=\"button\" class=\"btn btn-light btn-s\" (click)=\"removeAllPendingFiles()\">\n                    <i class=\"material-icons\">clear</i>&nbsp;{{'clearAll' | translate}}\n                </button>\n            </div>\n            <div *ngFor=\"let item of downloadFileList\">\n                <div class=\"file-row borders\">\n                    <div class=\"cell-center-align\">{{item.name}}</div>\n                    <div class=\"cell-center-align\"> {{round((item.size/1024),1)}} KB </div>\n                    <div class=\"cell-center-align\">\n                        <span>\n                            <i class=\"material-icons\" style=\"color: green;\">done</i>\n                        </span>\n                    </div>\n                    <div class=\"file-download-options cell-center-align\">\n                        <button type=\"button\" class=\"btn-default-transparent\" (click)=\"downloadFile(item)\">\n                            <i class=\"material-icons\">cloud_download</i>\n                        </button>\n                        <button *ngIf=\"!downloadOnly\" type=\"button\" class=\"btn-default-transparent\" [disabled]=\"isUploading\"\n                            (click)=\"deleteFile(item)\">\n                            <i class=\"material-icons\">clear</i>\n                        </button>\n                    </div>\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"cropperActive\" class=\"cropper-lay\">\n            <div class=\"cropper-lay-head\">\n                <button type=\"button\" class=\"btn-default-transparent\" (click)=\"closeImageCropper()\">\n                    <i class=\"material-icons\">arrow_back</i>\n                </button>\n                <div>{{currentImage != null ? currentImage.file.name:''}}</div>\n            </div>\n            <img-cropper #imgCropper [image]=\"{}\" [settings]=\"cropperSettings\"></img-cropper>\n            <div class=\"cropper-lay-footer\">\n                <button type=\"button\" class=\"btn btn-uniandes-main btn-s\" (click)=\"cropImage()\">\n                    <i class=\"material-icons\">crop</i>&nbsp;{{'cropImg' | translate}}\n                </button>\n                <button type=\"button\" class=\"btn btn-light btn-s\" (click)=\"closeImageCropper()\">\n                    <i class=\"material-icons\">clear</i>&nbsp;{{'close' | translate}}\n                </button>\n            </div>\n        </div>\n    </div>\n  ",
                    styles: ["\n    .btn{\n        display: flex;\n        justify-content: center;\n    }\n\n    .btn-default-transparent{\n        display: flex;\n        justify-content: center;\n        background-color: Transparent;\n        background-repeat:no-repeat;\n        border: none;\n        overflow: hidden;        \n    }\n\n    .btn-default-transparent:hover i{\n        color: red;\n        cursor: pointer;\n    }\n    .table-responsive{\n        display: grid;\n        grid-template-rows: 1fr;\n        border: 1px solid lightgray;\n    }\n\n    .file-row{\n       display: grid;\n       grid-template-columns: 2fr 2fr 1fr 1fr;\n\n    }\n\n    .file-row-img{\n        display: grid;\n        grid-template-columns: 1fr 2fr 2fr 1fr 1fr 1fr;\n \n     }\n\n     .imgThmb{\n    \n \n     }\n     .cropper-lay {\n        display: grid;\n        grid-template-rows: 45px 1fr 70px;\n        justify-items: center;\n        align-items: center;\n    }\n \n    .cropper-lay-head{\n        display: grid;\n        width: 100%;\n        grid-template-columns: 50px 1fr;\n        justify-items: center;\n        align-items: center;\n    }\n\n    .cropper-lay-footer{\n        display: grid;\n        width: 100%;\n        grid-template-columns: 1fr 1fr;\n        justify-items: center;\n        align-items: center;\n        grid-gap: 50px;\n        padding-left: 30px;\n        padding-right: 30px;\n    }\n \n    .cropper-lay-footer button{\n        width: 100%;\n    }\n    .borders{\n\n        padding: 10px;\n        border-bottom: 1px;\n        border-color: lightgray;\n        border-style: solid;\n        border-top: 0;\n        border-left: 0;\n        border-right: 0;\n        align-items: center;\n\n    }\n\n    .file-bottom{\n        display: grid;\n        grid-template-columns: 1fr 1fr;\n\n     }\n     .file-top{\n        display: grid;\n        grid-template-columns: 1fr 0.5fr 0.5fr 0.5fr 60px;\n     }\n    .file-controls{\n        display: grid;\n        grid-template-columns: 1fr 1fr 1fr;\n    }\n\n    .cell-center-align{\n        justify-items: center;\n        display: grid;\n        padding: 5px;\n    }\n\n    .file-download-options{\n        grid-template-columns: 1fr 1fr;\n    }\n\n\n    .lds-fil {\n        display: inline-block;\n        position: relative;\n        width: 25px;\n        height: 30px;\n      }\n      .lds-fil div {\n        display: inline-block;\n        position: absolute;\n        border-radius: 100px;\n        width: 4px;\n        background: black;\n        animation: lds-fil 1.2s cubic-bezier(0, 0.5, 0.5, 1) infinite;\n      }\n      .lds-fil div:nth-child(1) {\n        left: 1px;\n        animation-delay: -0.24s;\n      }\n      .lds-fil div:nth-child(2) {\n        left: 9px;\n        animation-delay: -0.12s;\n      }\n      .lds-fil div:nth-child(3) {\n        left: 17px;\n        animation-delay: 0;\n      }\n      @keyframes lds-fil {\n        0% {\n          top: 0;\n          height: 18px;\n        }\n        50%, 100% {\n          top: 6px;\n          height: 20px;\n        }\n      }\n      .progress-bar{\n          border-radius: 0;\n      }\n\n      .progress{\n          border-radius: 0;\n      }\n\n      .alert-borderless{\n        border-radius:0; \n        margin: 0;\n      }\n\n      .alert-borderless ul{\n        margin: 0;\n      }\n\n      .swal2-popup{\n        border-radius: 0 !important;\n       }\n\n        .swal2-popup .swal2-styled.swal2-confirm{\n            border: 0 !important;\n            background-color: #FFFF00 !important;\n            font-weight: normal !important;\n            color: #000 !important;\n        }\n\n       .swal2-popup .swal2-styled.swal2-cancel{\n            border: 0 !important;\n            background-color: #FFF !important;\n            font-weight: normal !important;\n            color: #000 !important;\n        }/*Common Styles*/\n    /*Buttons*/\n\n    .btn-uniandes-main { \n        color: #000000; \n        background-color: #FFFF00; \n        border-color: none; \n      } \n   \n      .btn-uniandes-main:hover, \n      .btn-uniandes-main:focus, \n      .btn-uniandes-main:active, \n      .btn-uniandes-main.active, \n      .open .dropdown-toggle.btn-uniandes-main { \n        color: #000000; \n        background-color: #DBD000; \n        border-color: none ; \n      } \n   \n      .btn-uniandes-main:active, \n      .btn-uniandes-main.active, \n      .open .dropdown-toggle.btn-uniandes-main { \n        background-image: none; \n      } \n   \n      .btn-uniandes-main.disabled, \n      .btn-uniandes-main[disabled], \n      fieldset[disabled] .btn-uniandes-main, \n      .btn-uniandes-main.disabled:hover, \n      .btn-uniandes-main[disabled]:hover, \n      fieldset[disabled] .btn-uniandes-main:hover, \n      .btn-uniandes-main.disabled:focus, \n      .btn-uniandes-main[disabled]:focus, \n      fieldset[disabled] .btn-uniandes-main:focus, \n      .btn-uniandes-main.disabled:active, \n      .btn-uniandes-main[disabled]:active, \n      fieldset[disabled] .btn-uniandes-main:active, \n      .btn-uniandes-main.disabled.active, \n      .btn-uniandes-main[disabled].active, \n      fieldset[disabled] .btn-uniandes-main.active { \n        background-color: #FFFF00; \n        border-color: none; \n      } \n   \n      .btn-uniandes-main .badge { \n        color: #FFFF00; \n        background-color: #000000; \n      }\n\n\n      .btn-uniandes-secondary { \n        color: #ffffff; \n        background-color: #000000; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary:hover, \n      .btn-uniandes-secondary:focus, \n      .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.active, \n      .open .dropdown-toggle.btn-uniandes-secondary { \n        color: #ffffff; \n        background-color: #707070; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.active, \n      .open .dropdown-toggle.btn-uniandes-secondary { \n        background-image: none; \n      } \n   \n      .btn-uniandes-secondary.disabled, \n      .btn-uniandes-secondary[disabled], \n      fieldset[disabled] .btn-uniandes-secondary, \n      .btn-uniandes-secondary.disabled:hover, \n      .btn-uniandes-secondary[disabled]:hover, \n      fieldset[disabled] .btn-uniandes-secondary:hover, \n      .btn-uniandes-secondary.disabled:focus, \n      .btn-uniandes-secondary[disabled]:focus, \n      fieldset[disabled] .btn-uniandes-secondary:focus, \n      .btn-uniandes-secondary.disabled:active, \n      .btn-uniandes-secondary[disabled]:active, \n      fieldset[disabled] .btn-uniandes-secondary:active, \n      .btn-uniandes-secondary.disabled.active, \n      .btn-uniandes-secondary[disabled].active, \n      fieldset[disabled] .btn-uniandes-secondary.active { \n        background-color: #000000; \n        border-color: none; \n      } \n   \n      .btn-uniandes-secondary .badge { \n        color: #000000; \n        background-color: #ffffff; \n      }\n\n    /*Dialogs*/\n    .modal-header{\n        padding: 0px;\n        border: 0px;\n        background-color: #FFFF00;\n    }\n\n    .modal-header table{\n        margin: 0px;\n        border: 0px;   \n        width: 100%;\n    }\n\n    .modal-header table tr td{\n        padding: 10px;\n    \n    }\n    .modal-body{\n        padding-bottom: 20px;\n        margin-left: 20px;\n        margin-right: 20px;\n    }\n\n    .title-element{\n        padding-top: 5px;\n        padding-bottom: 5px;\n    }\n    .modal-content{\n        border-radius: 0px;\n        border: 0px;\n    }\n\n    .modal-header{\n          border-radius: 0;\n    }\n  "]
                },] },
    ];
    /** @nocollapse */
    FileSelectComponent.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
        { type: file_select_service_1.FileSelectService, },
        { type: core_2.TranslateService, },
        { type: platform_browser_1.DomSanitizer, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [common_1.DOCUMENT,] },] },
    ]; };
    FileSelectComponent.propDecorators = {
        "fileSelectId": [{ type: core_1.Input },],
        "downloadFileList": [{ type: core_1.Input },],
        "disableDownload": [{ type: core_1.Input },],
        "disableUpload": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "imageThumbnailHeight": [{ type: core_1.Input },],
        "setOtherParameters": [{ type: core_1.Input, args: ['otherParameters',] },],
        "setUploadServiceUrl": [{ type: core_1.Input, args: ['uploadServiceUrl',] },],
        "setDownloadServiceUrl": [{ type: core_1.Input, args: ['downloadServiceUrl',] },],
        "setDeleteServiceUrl": [{ type: core_1.Input, args: ['deleteServiceUrl',] },],
        "setDownloadListServiceUrl": [{ type: core_1.Input, args: ['downloadListServiceUrl',] },],
        "maxFiles": [{ type: core_1.Input },],
        "cropperWidth": [{ type: core_1.Input },],
        "cropperHeight": [{ type: core_1.Input },],
        "cropperOutWidth": [{ type: core_1.Input },],
        "cropperOutHeight": [{ type: core_1.Input },],
        "extensionsList": [{ type: core_1.Input },],
        "maxFileSize": [{ type: core_1.Input },],
        "downloadOnly": [{ type: core_1.Input },],
        "singleRequestUpload": [{ type: core_1.Input },],
        "onFileUploadSuccess": [{ type: core_1.Output },],
        "onFileUploadError": [{ type: core_1.Output },],
        "onSingleRequestUploadSuccess": [{ type: core_1.Output },],
        "onSingleRequestUploadError": [{ type: core_1.Output },],
        "onFileDeleteSuccess": [{ type: core_1.Output },],
        "onFileDeleteError": [{ type: core_1.Output },],
        "onFileListUpdate": [{ type: core_1.Output },],
        "uplder": [{ type: core_1.ViewChild, args: ["uplder",] },],
        "imgCropper": [{ type: core_1.ViewChild, args: ['imgCropper',] },],
    };
    return FileSelectComponent;
}(ng2_file_upload_1.FileUploader));
exports.FileSelectComponent = FileSelectComponent;
//# sourceMappingURL=file-select.component.js.map