"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var search_academy_combo_box_component_1 = require("../../search-academy-combo-box/search-academy-combo-box.component");
var service_locator_1 = require("../../../service-locator");
var search_combo_box_service_1 = require("../../search-combo-box.service");
var core_2 = require("@ngx-translate/core");
var titlecase_academia_pipe_1 = require("../../../utils/titlecase-academia.pipe");
var search_combo_box_generic_model_1 = require("../../search-combo-box-generic/search-combo-box-generic.model");
var CityComboBoxComponent = /** @class */ (function (_super) {
    __extends(CityComboBoxComponent, _super);
    function CityComboBoxComponent(urlService, searchBoxUtils, transService, titlecasePipe) {
        var _this = _super.call(this, urlService, searchBoxUtils, transService, new search_combo_box_generic_model_1.SearchComboBoxGenericModel(urlService.getCityUrlLegacy(), [{ 'name': 'limit', 'value': 10 }], null, 'cities', null, 'Search Cities'), titlecasePipe) || this;
        _this.urlService = urlService;
        _this.searchBoxUtils = searchBoxUtils;
        _this.transService = transService;
        _this.titlecasePipe = titlecasePipe;
        return _this;
    }
    CityComboBoxComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        if (this.debugFlag) {
            this.model.urlService = this.urlService.getCityUrlLegacy(this.debugFlag);
        }
    };
    CityComboBoxComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
    };
    CityComboBoxComponent.prototype.sendItemSelectedEvent = function (event) {
        this.itemSelected.emit(event);
    };
    CityComboBoxComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-city-combo-box',
                    template: "\n    <ng-template #customItemTemplate let-model=\"item\" let-index=\"index\">\n      <div class=\"card-container\">\n          <div class=\"item\" ><p><span>{{model.name}}</span></p></div>\n      </div>\n    </ng-template>\n\n    <app-search-combo-box-generic  [customTemplate]=\"customItemTemplate\" [preSelectedValue]= \"preSelectedValue\" [componentModel]=\"model\" [itemControl]=\"itemControl\" [isScrollable]=\"isScrollable\" (noResults)=\"sendNoResults($event)\" (itemSelected)=\"sendItemSelectedEvent($event)\"></app-search-combo-box-generic>\n  ",
                    styles: ["\n\n  "]
                },] },
    ];
    /** @nocollapse */
    CityComboBoxComponent.ctorParameters = function () { return [
        { type: service_locator_1.ServiceLocator, },
        { type: search_combo_box_service_1.SearchComboBoxService, },
        { type: core_2.TranslateService, },
        { type: titlecase_academia_pipe_1.TitleCaseAcademiaPipe, },
    ]; };
    return CityComboBoxComponent;
}(search_academy_combo_box_component_1.SearchAcademyComboBoxComponent));
exports.CityComboBoxComponent = CityComboBoxComponent;
//# sourceMappingURL=city-combo-box.component.js.map