import { OnInit, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { FormControl } from '@angular/forms';
import { SearchComboBoxGenericModel } from '../search-combo-box-generic/search-combo-box-generic.model';
import { ServiceLocator } from '../../service-locator';
import { SearchComboBoxService } from '../search-combo-box.service';
import { TranslateService } from '@ngx-translate/core';
import { TitleCaseAcademiaPipe } from '../../utils/titlecase-academia.pipe';
export declare abstract class SearchAcademyComboBoxComponent implements OnInit, OnChanges {
    urlService: ServiceLocator;
    searchBoxUtils: SearchComboBoxService;
    transService: TranslateService;
    model: SearchComboBoxGenericModel;
    titlecasePipe: TitleCaseAcademiaPipe;
    itemControl: FormControl;
    debugFlag: boolean;
    isScrollable: boolean;
    placeHolder: any;
    preSelectedValue: string;
    queryParams: any[];
    itemSelected: EventEmitter<any>;
    noResults: EventEmitter<any>;
    typeLoading: EventEmitter<any>;
    totalRecordsForSearch: EventEmitter<any>;
    private genCombo;
    constructor(urlService: ServiceLocator, searchBoxUtils: SearchComboBoxService, transService: TranslateService, model: SearchComboBoxGenericModel, titlecasePipe: TitleCaseAcademiaPipe);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    prepareQueryParams(queryParams: any): void;
    addQueryParams(qp: any): void;
    sendItemSelectedEvent(event: any): void;
    sendNoResults(event: any): void;
    sendLoading(event: any): void;
    addUserNameRestriction(userData: any, param: string): void;
}
