"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var service_locator_1 = require("../../service-locator");
var search_combo_box_service_1 = require("../search-combo-box.service");
var core_2 = require("@ngx-translate/core");
var search_combo_box_generic_model_1 = require("../search-combo-box-generic/search-combo-box-generic.model");
var search_academy_combo_box_component_1 = require("../search-academy-combo-box/search-academy-combo-box.component");
var titlecase_academia_pipe_1 = require("../../utils/titlecase-academia.pipe");
var SearchCoreFacilitiesComboBoxComponent = /** @class */ (function (_super) {
    __extends(SearchCoreFacilitiesComboBoxComponent, _super);
    function SearchCoreFacilitiesComboBoxComponent(urlService, searchBoxUtils, transService, titlecasePipe) {
        var _this = _super.call(this, urlService, searchBoxUtils, transService, new search_combo_box_generic_model_1.SearchComboBoxGenericModel(urlService.getCorefacilityUrl(), [{ "name": "limit", "value": 10 }], null, "facilities", "name", 'Search Countries'), titlecasePipe) || this;
        _this.urlService = urlService;
        _this.searchBoxUtils = searchBoxUtils;
        _this.transService = transService;
        _this.titlecasePipe = titlecasePipe;
        // constructor(urlService: string,queryParams: any[],body?:any,collectionName?:string, optionField?: string, placeholder?: string, optionsLimit?: number, findBy?:string){
        return _this;
    }
    Object.defineProperty(SearchCoreFacilitiesComboBoxComponent.prototype, "usernameRestrict", {
        set: function (userdata) {
            this.addUserNameRestriction(userdata);
        },
        enumerable: true,
        configurable: true
    });
    SearchCoreFacilitiesComboBoxComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        if (this.debugFlag) {
            this.model.urlService = this.urlService.getCorefacilityUrl(this.debugFlag);
        }
        this.setUrlServiceHost();
    };
    SearchCoreFacilitiesComboBoxComponent.prototype.sendItemSelectedEvent = function (event) {
        this.itemSelected.emit(event);
    };
    SearchCoreFacilitiesComboBoxComponent.prototype.setUrlServiceHost = function () {
        if (this.debugFlag) {
            this.model.urlService = this.urlService.getCorefacilityUrl(this.debugFlag);
        }
    };
    SearchCoreFacilitiesComboBoxComponent.prototype.addUserNameRestriction = function (userData) {
        if (userData != null) {
            this.setUrlServiceHost();
            this.coreCombo.componentModel = this.model;
            if (userData['dependency']) {
                var extId = userData['dependency']['externalId'];
                _super.prototype.addQueryParams.call(this, { "name": "dependencyExternalId", "value": extId });
                this.coreCombo.setInitialValue(userData['dependency']);
            }
        }
    };
    SearchCoreFacilitiesComboBoxComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-search-core-facilities-combo-box',
                    template: "\n    <ng-template #customItemTemplate let-model=\"item\" let-index=\"index\">\n      <div class=\"card-container\">\n          <div class=\"item\"><p><span>{{model.name | titleCaseAcademia}}</span></p></div>\n      </div>\n    </ng-template>\n\n    <app-search-combo-box-generic #corecombo [customTemplate]=\"customItemTemplate\" [preSelectedValue]= \"preSelectedValue\" [componentModel]=\"model\" [itemControl]=\"itemControl\" [isScrollable]=\"isScrollable\" (noResults)=\"sendNoResults($event)\" (itemSelected)=\"sendItemSelectedEvent($event)\"></app-search-combo-box-generic>\n  ",
                    styles: ["\n\n  "]
                },] },
    ];
    /** @nocollapse */
    SearchCoreFacilitiesComboBoxComponent.ctorParameters = function () { return [
        { type: service_locator_1.ServiceLocator, },
        { type: search_combo_box_service_1.SearchComboBoxService, },
        { type: core_2.TranslateService, },
        { type: titlecase_academia_pipe_1.TitleCaseAcademiaPipe, },
    ]; };
    SearchCoreFacilitiesComboBoxComponent.propDecorators = {
        "usernameRestrict": [{ type: core_1.Input, args: ['userRestrict',] },],
        "coreCombo": [{ type: core_1.ViewChild, args: ['corecombo',] },],
    };
    return SearchCoreFacilitiesComboBoxComponent;
}(search_academy_combo_box_component_1.SearchAcademyComboBoxComponent));
exports.SearchCoreFacilitiesComboBoxComponent = SearchCoreFacilitiesComboBoxComponent;
//# sourceMappingURL=search-core-facilities-combo-box.component.js.map