"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var service_locator_1 = require("../../../service-locator");
var Observable_1 = require("rxjs/Observable");
var DependencyService = /** @class */ (function () {
    function DependencyService(http, urlService) {
        this.http = http;
        this.urlService = urlService;
        this.headers = new http_1.HttpHeaders();
        this.headers.append('Content-Type', 'application/json');
    }
    DependencyService.prototype.getDependencies = function (params) {
        if (params) {
            params.offset = 0;
            params.limit = 200; // Get all dependencies
        }
        else {
            params = { offset: 0, limit: 200 };
        }
        //return this.http.get("../../../../assets/mocks/dependencies.json");
        return this.http.get(this.urlService.getDependencyUrl(true), { params: params, headers: this.headers }).catch(this.handleError);
    };
    DependencyService.prototype.handleError = function (error) {
        return Observable_1.Observable.throw(error.statusText || 'Server error');
    };
    DependencyService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    DependencyService.ctorParameters = function () { return [
        { type: http_1.HttpClient, },
        { type: service_locator_1.ServiceLocator, },
    ]; };
    return DependencyService;
}());
exports.DependencyService = DependencyService;
//# sourceMappingURL=dependency.service.js.map