"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var utils_service_1 = require("./utils.service");
var TitleCaseAcademiaPipe = /** @class */ (function () {
    function TitleCaseAcademiaPipe(utilService) {
        this.utilService = utilService;
    }
    TitleCaseAcademiaPipe.prototype.transform = function (value, args) {
        if (value) {
            var valueToLowerCase = value.toLowerCase();
            var splitInWords = valueToLowerCase.split(" ");
            var splitInWordsUpperCase = this.utilService.clearUndefinedValuesInArray(splitInWords);
            splitInWordsUpperCase = splitInWords.map(function (elm) {
                if (elm && elm != " ") {
                    return elm[0].toUpperCase() + elm.slice(1);
                }
            });
            var reducer = function (acc, value) { return acc + " " + value; };
            return splitInWordsUpperCase.reduce(reducer);
        }
        else {
            return undefined;
        }
    };
    TitleCaseAcademiaPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'titleCaseAcademia'
                },] },
    ];
    /** @nocollapse */
    TitleCaseAcademiaPipe.ctorParameters = function () { return [
        { type: utils_service_1.UtilsService, },
    ]; };
    return TitleCaseAcademiaPipe;
}());
exports.TitleCaseAcademiaPipe = TitleCaseAcademiaPipe;
//# sourceMappingURL=titlecase-academia.pipe.js.map